c-------------------------------------------------------------------      
      subroutine allshift (typ)
c--------------------------------------------------------------------
      use datos, only : stdout1, x, y, z, multim, nin,
     & bmin, bmax, bincrem1, bincrem2, tmin, tmax, tincrem1, tincrem2,
     & tincrem3, ltot, test, llin1, llin2, rinc, alphin, betin, alph,
     & bet   
      implicit real*8 (a-h,o-z)   
c......typ is a integer number that is equal to 0,1
c......for exploration in two- and three-dimensional shift
      integer :: typ  
c.....LOCAL VARIABLES:
      integer :: i, k, l, ib, it, totb, tott
      real*8 :: ra(3), rb(3), rab(3), r1new(3), r2new(3)
      real*8 :: u(3), v(3), w(3)

c.....Initializations
      totb = 0; tott = 1
c.....Obtain the vector linking the nuclei A and B
      rab(1) = x(2) - x(1);rab(2) = y(2) - y(1);rab(3) = z(2) - z(1)
c.....Radio vectors for nucleus A and nucleus B
      ra(1) = x(1);ra(2) = y(1);ra(3) = z(1)
      rb(1) = x(2);rb(2) = y(2);rb(3) = z(2)
c.....Shift multipole moments (See Stone's book: p.32-35)
      if (typ.eq.0) then
c......Unitary vector "u" in the direction linking the nuclei
       u = rab/sqrt(dot_product(rab,rab))
c......Unitary vector "v" orthogonal to vector "u" (arbitrary selection)
       v(1) = 0d0;v(2) = u(3);v(3) = - u(2)
       v = v/sqrt(dot_product(v,v))
       do k = 0, llin1 - 1
        totb = totb+1
        write (stdout1,fmt=60)
        alph = k*alphin
        write (stdout1,fmt=50) totb,alph
        write (stdout1,fmt=600)
        bincrem1 = rinc*cos(alph)
        bincrem2 = rinc*sin(alph)
        ib = 0
        do i = bmin, bmax
         ib = ib + 1
c........Initializate new out betasphere multipole 
c........moments for each loop
         multim(5:6,0:ltot,0:ltot,1:2) = 0d0
c........Calculate new centers
         r1new = ra - bincrem1*i*u - bincrem2*i*v
         r2new = rb + bincrem1*i*u + bincrem2*i*v
         x(3) = r1new(1)
         y(3) = r1new(2)
         z(3) = r1new(3)
         x(4) = r2new(1)
         y(4) = r2new(2)
         z(4) = r2new(3)
c........Shift out beta sphere multipole moments
         nin = 1 !Coordiantes and OUT multipole moments for atom1
         call shift_mm()
         nin = 2 !Coordinates and OUT multipole moments for atom2
         call shift_mm()
c........Calculate Coulomb interactions between atoms 1 and 2
         call energy(ib)   
c........Test convergence on 4 interactions: BETA(A)-BETA(B),
c........OUT(A)-OUT(B),BETA(A)-OUT(B),BETA(B)-OUT(A)
         if (test(1).ne.0.and.test(2).ne.0.and.
     & test(3).ne.0.and.test(4).ne.0) then
          goto 11
         else
          goto 2
         endif
2        continue
        enddo
       enddo
      else 
c......Unitary vector "u" in the direction linking the nuclei
       u = rab/sqrt(dot_product(rab,rab))
c......Unitary vector "v" orthogonal to vector "u" (arbitrary selection)
       v(1) = 0d0;v(2) = u(3);v(3) = - u(2)
       v = v/sqrt(dot_product(v,v))
c......Unitary vector "w" orthogonal to vectors "u" and "v"
c......(arbitrary selection in the direction)
       w(1) = 1d0
       w(2) = - u(1)*u(2)/(u(2)**2+u(3)**2)
       w(3) = - u(1)*u(3)/(u(2)**2+u(3)**2) 
       w = w/sqrt(dot_product(w,w))
C......Shift in W axis
       write (stdout1,fmt=80)
       write (stdout1,fmt=90)
       bet = 0d0
       write (stdout1,fmt=70) tott,bet
       write (stdout1,fmt=600)
       tincrem3 = rinc
       tincrem1 = 0d0
       tincrem2 = 0d0
       it = 0 
       do i = tmin, tmax
        it = it + 1 
c.......Initializate new out betasphere multipole 
c.......moments for each loop
        multim(5:6,0:ltot,0:ltot,1:2) = 0d0
c.......Calculate new centers
        r1new = ra - tincrem1*i*u - tincrem2*i*v - tincrem3*i*w
        r2new = rb + tincrem1*i*u + tincrem2*i*v + tincrem3*i*w
        x(3) = r1new(1)
        y(3) = r1new(2)
        z(3) = r1new(3)
        x(4) = r2new(1)
        y(4) = r2new(2)
        z(4) = r2new(3)
c.......Shift out beta sphere multipole moments
        nin = 1 !Coordiantes and OUT multipole moments for atom1
        call shift_mm()
        nin = 2 !Coordinates and OUT multipole moments for atom2
        call shift_mm()
c.......Calculate Coulomb interactions between atoms 1 and 2
        call energy(it)    
c.......Test convergence on 4 interactions: BETA(A)-BETA(B),
c.......OUT(A)-OUT(B),BETA(A)-OUT(B),BETA(B)-OUT(A)
        if (test(1).ne.0.and.test(2).ne.0.and.
     & test(3).ne.0.and.test(4).ne.0) then
         goto 11
        else
         goto 3
        endif
3       continue
       enddo     
       do k = 1, llin1 - 1
        tott = tott + 1
        write (stdout1,fmt=80)
        bet = k*betin 
        write (stdout1,fmt=70) tott,bet
        tincrem3 = rinc*cos(bet)
        totb = 0
        do l = 0, llin2 -1
         totb = totb + 1
         write (stdout1,fmt=60)
         alph = l*alphin
         write (stdout1,fmt=50) totb,alph
         write (stdout1,fmt=600)
         tincrem1 = rinc*sin(bet)*cos(alph)
         tincrem2 = rinc*sin(bet)*sin(alph)
         it = 0 
         do i = tmin, tmax
          it = it + 1 
c.........Calculate new centers
          r1new = ra - tincrem1*i*u - tincrem2*i*v - tincrem3*i*w
          r2new=rb + tincrem1*i*u + tincrem2*i*v + tincrem3*i*w
          x(3) = r1new(1)
          y(3) = r1new(2)
          z(3) = r1new(3)
          x(4) = r2new(1)
          y(4) = r2new(2)
          z(4) = r2new(3)
c.........Shift out beta sphere multipole moments
          nin = 1 !Coordiantes and OUT multipole moments for atom1
          call shift_mm()
          nin = 2 !Coordinates and OUT multipole moments for atom2
          call shift_mm()
c.........Calculate Coulomb interactions between atoms 1 and 2
          call energy(it)   
c.........Test convergence on 4 interactions: BETA(A)-BETA(B),
c.........OUT(A)-OUT(B),BETA(A)-OUT(B),BETA(B)-OUT(A)
          if (test(1).ne.0.and.test(2).ne.0.and.
     & test(3).ne.0.and.test(4).ne.0) then
           goto 11
          else
           goto 4
          endif
4         continue
         enddo
        enddo
       enddo
      endif
11    continue
c.....Formats
 600  format (1x,'# ITERATION',2x,'RANK: BETA(1-2)',1x,'OUT(1-2)',1x,
     & 'BETA-OUT(1-2)',1x,'BETA-OUT(2-1)',1x,'ENERGY(u.a)',13x,
     & 'ENERGY(kJ/mol)')
 50   format (1x,'# ALPHA ITERATION=',1x,i5,/,
     &1x,'# ALPHA ANGLE=',1x,f10.6,1x,'RADIANS')
 70   format (1x,'# BETA ITERATION=',1x,i5,/,
     &1x,'# BETA ANGLE=',1x,f10.6,1x,'RADIANS')
 60   format ('*******************************************************
     &********************')
 80   format ('=======================================================
     &====================')
 90   format (1x,'# SHIFT IN W AXIS')
c                  
      return
      end

