c---------------------------------------------------------------------------
      subroutine calc_coef()
c---------------------------------------------------------------------------
      use datos, only : neq1, neq2, eq1, eq2, rank, cof, 
     & xyz, R, thetaAB, phiAB, slm, il0, ltotm, charge, qlmtot,
     & rhoqlm, bsphere, ineq
      use libreria, only : bol, rsh, T2
      implicit real*8 (a-h,o-z)
c.....LOCAL VARIABLES:
      integer :: i, Lloop, l, m, lm, l1, l2, m1, m2, lm1, lm2
      real*8 :: Tensor
      real*8, dimension (3) :: RA, RB, RAB
      real*8, dimension (:) :: QA(0:(rank-1)*(rank+1)),
     & QB(0:(rank-1)*(rank+1))

c     Calculate nuclear polar coordinates and initializations
      do i = 1, 3
       RA(i) = xyz(eq1,i)
       RB(i) = xyz(eq2,i)
      enddo
      RAB = RB - RA
      call bol (RAB,R,thetaAB,phiAB)
      call rsh (thetaAB,phiAB,slm,il0,ltotm)
c     Obtain total multipole moments
      do l = 0, rank-1
          do m = -l,+l
           lm = l*(l+1) + m
           if (bsphere) then
            if (lm.eq.0) then
             QA(lm)=charge(eq1)-qlmtot(neq1,lm)
             QB(lm)=charge(eq2)-qlmtot(neq2,lm)
            else
             QA(lm)=-qlmtot(neq1,lm)
             QB(lm)=-qlmtot(neq2,lm)
            endif
           else
            if (lm.eq.0) then
             QA(lm)=charge(eq1)-rhoqlm(neq1,lm)
             QB(lm)=charge(eq2)-rhoqlm(neq2,lm)
            else
             QA(lm)=-rhoqlm(neq1,lm)
             QB(lm)=-rhoqlm(neq2,lm)
            endif
           endif
           if (abs(QA(lm)).lt.1d-20) QA(lm)=0d0
           if (abs(QB(lm)).lt.1d-20) QB(lm)=0d0
          enddo
         enddo
c     Obtain coefficients for multipolar expansion energy
      cof=0.d0
      do Lloop=1,rank
       do l1=Lloop-1,0,-1
        l2=Lloop-1-l1
        do m1=-l1,l1
          lm1 = l1*(l1+1) + m1
         do m2=-l2,l2
          lm2 = l2*(l2+1) + m2 
          Tensor=T2(l1,m1,l2,m2)*R**Lloop
          cof(Lloop)=cof(Lloop)+QA(lm1)*Tensor*QB(lm2)
         enddo
        enddo
       enddo
      enddo
c
c-----End of the subroutine
c
      return
      end subroutine

