       subroutine calcelecBE2 ()
c-----------------------------------------------------------------------
c      From BE, this subroutine calculates the Coulomb interactions
c      between two atomic basins until convergence
c-----------------------------------------------------------------------
        use datos, only : neq1, neq2, eq1, eq2, R, stdout1,
     & xyz, afactor, charge, qnlmtot, rhoqnlm, bsphere,
     & sigm, sigmtot, thetaAB, phiAB, slm, il0, pi,
     & ltot, ltotm, ntot, VBE, VBE2, ineq
        use libreria, only : bol, rsh, lagpol_0, tensor, itoa, leng 
        implicit real*8 (a-h,o-z)
c-----LOCAL VARIABLES:
        integer :: testBE 
        integer :: i
        integer :: n, noop, n1, n2
        integer :: l, l1, l2
        integer :: m, m1, m2
        integer :: lm, lm1, lm2
        real*8 :: cte, cteB 
        real*8, dimension (:) :: conv(0:ntot+1)
        real*8, dimension (:) :: RA(3), RB(3), RAB(3)
        real*8, dimension (:) :: lagpol0(0:ntot) 
        real*8, dimension (:,:) :: QA(0:ntot,0:ltot*(ltot+2)),
     & QB(0:ntot,0:ltot*(ltot+2))  
        character*16 :: number
        character*2 :: car 

        cte = 1.d0/sqrt(4.d0*pi)
c-----Calculate nuclear polar coordinates and real spherical harmonics
        do i = 1, 3
         RA(i) = xyz(eq1,i)
         RB(i) = xyz(eq2,i)
        enddo
        RAB = RB - RA
        call bol (RAB,R,tethaAB,phiAB)
        sigm = R/afactor 
        sigmtot = 1.d0/sqrt(2.d0*sigm**(-2)) 
        call rsh (thetaAB, phiAB, slm, il0, ltotm)
        call lagpol_0 (ntot, lagpol0) 
c-----Obtain total multipole moments
         do n = 0, ntot
          do l = 0, ltot
           do m = -l,+l
            lm = l*(l+1) + m
            if (bsphere) then
             if (lm.eq.0) then 
              QA(n,lm)=charge(eq1)*lagpol0(n)
     & *cte-qnlmtot(neq1,n,lm)
              QB(n,lm)=charge(eq2)*lagpol0(n)
     & *cte-qnlmtot(neq2,n,lm)
             else
              QA(n,lm)=-qnlmtot(neq1,n,lm)
              QB(n,lm)=-qnlmtot(neq2,n,lm)
             endif
            else
             if (lm.eq.0) then
              QA(n,lm)=charge(eq1)*lagpol0(n)
     & *cte-rhoqnlm(neq1,n,lm)
              QB(n,lm)=charge(eq2)*lagpol0(n)
     & *cte-rhoqnlm(neq2,n,lm)
             else
              QA(n,lm)=-rhoqnlm(neq1,n,lm)
              QB(n,lm)=-rhoqnlm(neq2,n,lm)
             endif
            endif
            if (abs(QA(n,lm)).lt.1d-20) QA(n,lm)=0d0
            if (abs(QB(n,lm)).lt.1d-20) QB(n,lm)=0d0
           enddo
          enddo
         enddo
c-----Obtain electrostatic interaction
         VBE = 0d0 !Initializations
         conv=0d0 ; testBE=0 !Initializations
         do noop = 1, ntot+1
          conv(noop)=conv(noop-1)
          do n1 = noop-1, 0, -1
           n2 = noop-1-n1
           do l1 = 0, ltot
            do l2 = 0, ltot
             do m1 = -l1, +l1
              lm1 = l1*(l1+1) + m1
              do m2 = -l2, l2
               lm2 = l2*(l2+1) + m2
               cteB=QA(n1,lm1)*tensor(n1,l1,m1,n2,l2,m2)*QB(n2,lm2)
               VBE = VBE + cteB
               conv(noop) = conv(noop) + cteB
              enddo
             enddo
            enddo
           enddo
          enddo
          if (noop.gt.4) then
           if (abs(conv(noop)-conv(noop-1)).lt.convt.and.
     &         abs(conv(noop)-conv(noop-2)).lt.convt.and.
     &         abs(conv(noop)-conv(noop-3)).lt.convt) then
            testBE = noop
            goto 1
           endif
          endif
         enddo

 1       VBE2 = VBE*2625.5d0
         if (testBE.ne.0) then
          number=itoa(testBE)
          car=number(1:leng(number))
         else
          car='NC'
         endif
         write (stdout1, fmt=400) car, VBE, VBE2
c
c-----Formats
c
 400  format (1x,a,3x,e23.16,1x,e23.16) 
c
c.....end
c
      return
      end
 
