       subroutine calcelecME ()
c-----------------------------------------------------------------------
c      From ME, this subroutine calculates the Coulomb interactions
c      between two atomic basins 
c-----------------------------------------------------------------------
        use datos, only : neq1, neq2, eq1, eq2, 
     & xyz, charge, qlmtot, rhoqlm, bsphere, thetaAB, phiAB,
     & ltot, ltotm,TtildaLabel, TtildaList, c, tra, trb, R, VMEP, VMEP2,
     & VMEO, VMEO2, slm, il0, ineq
        use libreria, only : T, T2, bol, rsh 
        implicit real*8 (a-h,o-z)
c-----LOCAL VARIABLES:
        integer :: i
        integer :: l, l1, l2
        integer :: m, m1, m2
        integer :: lm, lm1, lm2
        real*8, dimension (:) :: RA(3), RB(3), RAB(3), uAB(3)
        real*8, dimension (:) :: QA(0:ltot*(ltot+2)),
     & QB(0:ltot*(ltot+2)) 
        real*8 :: Tensor,  cte, Tensoro, cteo

c-----Calculate nuclear polar coordinates and initializations
        TtildaLabel = 0
        TtildaList = 0d0
        c = 0d0
        c(1,1)=1d0;c(2,2)=1d0;c(3,3)=1d0 !c is 3*3 unitary matrix
        do i = 1, 3
         RA(i) = xyz(eq1,i)
         RB(i) = xyz(eq2,i)
        enddo
        RAB = RB - RA
        call bol (RAB,R,thetaAB,phiAB)
        call rsh (thetaAB, phiAB, slm, il0, ltotm)
        uAB = RAB/R
        tra = uAB
        trb = -uAB
c-----Obtain total multipole moments
         do l = 0, ltot
          do m = -l,+l
           lm = l*(l+1) + m
           if (bsphere) then
            if (lm.eq.0) then 
             QA(lm)=charge(eq1)-qlmtot(neq1,lm) 
             QB(lm)=charge(eq2)-qlmtot(neq2,lm)
            else
             QA(lm)=-qlmtot(neq1,lm)
             QB(lm)=-qlmtot(neq2,lm)
            endif
           else
            if (lm.eq.0) then
             QA(lm)=charge(eq1)-rhoqlm(neq1,lm)
             QB(lm)=charge(eq2)-rhoqlm(neq2,lm)
            else
             QA(lm)=-rhoqlm(neq1,lm)
             QB(lm)=-rhoqlm(neq2,lm)
            endif
           endif 
           if (abs(QA(lm)).lt.1d-20) QA(lm)=0d0
           if (abs(QB(lm)).lt.1d-20) QB(lm)=0d0
          enddo
         enddo
c-----Obtain electrostatic interaction
         VMEP = 0d0 !Initializations
         VMEO = 0d0 !Initializations 
         do l1 = 0, ltot
          do l2 = 0, ltot
           do m1 = -l1, +l1
            lm1 = l1*(l1+1) + m1
            do m2 = -l2, l2
             lm2 = l2*(l2+1) + m2
             Tensor=T(l1,m1,l2,m2)
             Tensoro=T2(l1,m1,l2,m2)
             cte=QA(lm1)*Tensor*QB(lm2) 
             cteo=QA(lm1)*Tensoro*QB(lm2)
             VMEP = VMEP + cte
             VMEO = VMEO + cteo
            enddo
           enddo
          enddo
         enddo
         VMEP2 = VMEP*2625.5d0
         VMEO2 = VMEO*2625.5d0 
c
c.....end
c
      return
      end 
