       subroutine calcqnlm (nmax,lmax,lmax2,nrp,rp,wrp,rlm,qnlm)
c-------------------------------------------------------------------
c      This subroutine obtain Qnlm values for the electron density
c-------------------------------------------------------------------
        use datos, only: neq, pi, afactor
        use libreria, only : lagpol 
        implicit real*8 (a-h,o-z)
        integer :: nmax, lmax, lmax2, nrp
        real*8, dimension (:,:) :: rp(0:nrp-1,1:neq), wrp(0:nrp-1,1:neq)
        real*8, dimension (:,:,:) :: rlm(0:nrp-1,1:neq,0:lmax2),
     & qnlm(1:neq,0:nmax,0:lmax2)
c-----LOCAL VARIABLES:
        integer :: ic, n, l, m, lm, i
        real*8 :: alpha, numb, Nl, y, xlm
c
c-----calculate 'qnlm' values for the electron density
c
c-----loop over no equivalent centers
      do ic = 1, neq
c-----loop over orthogonal expansion
       do n = 0, nmax
c-----loop over angular quantum numbers (l,m)
        do l = 0, lmax
         alpha = l + 0.5d0 !index for associated Laguerre polynomials
         numb = 4.d0*pi / (2.d0*l+1.d0)
         Nl = sqrt(numb) !angular normalization constant
         do m = -l, +l
          lm = l*(l+1) + m
c-----loop over radial grid points
          do i = 0, nrp-1
           y = rp(i,ic) / afactor !variable for associated Laguerre
                                  !polynomials
           xlm = rlm(i,ic,lm)*wrp(i,ic) 
           qnlm(ic,n,lm) = qnlm(ic,n,lm) + lagpol(n,alpha,y)*xlm
          enddo
          qnlm(ic,n,lm) = qnlm(ic,n,lm) / Nl
         enddo
        enddo
       enddo
      enddo
c
c.....end
c
      return
      end
