c-----------------------------------------------------------------
      subroutine datarholm ()
c
c.....Routine that reads the inputfile generate for promolden subroutine
c     "wrinfo".
c
c...............................................................
c
       use datos, only : stdin2, word, line, faterr, arg, filename,
     & nmo, nprims, ncent, atnam, xyz, charge, nfun, nop, neq, ineq,
     & idx, oper, itask, rmaxsurf, lmax, leb, iqudt, mapt, mmap,
     & npang, nptheta, npphi, ct, st, cp, sp, angw, nr, doromberg,
     & iqudr, mapr, alfm, mpr, xyzrho, rmesh, wrmesh, bsphere, llmax,
     & lebb, npangb, npthetab, npphib, ctb, stb, cpb, spb, angwb, nrb,
     & iqudrb, maprb, betrad, rbet, wrbet, lmax2, llmax2, lmax21,
     & llmax21, lpmin, lpmax  
       use libreria, only : error, setword, leng
       implicit real*8 (a-h,o-z)
c
c.................................................................
c
c.....Test that read the correct promolden_.wfn.pdat file
c     
      read (stdin2, 500) line
      lp = 1
      la = leng (arg(1))
      if (setword(word, line, lp)) then
       if (word.ne.'WFN')
     &  call error ('datarholm', 'error while reading '//
     &arg(1)(1:la), faterr)  
      else
       call error ('datarholm', 'error while reading '//
     &arg(1)(1:la), faterr)
      endif
500   format (////5x,a)
c
c.....WFN info
c
      read (stdin2,100) filename
      read (stdin2,101) nmo, nprims, ncent
      allocate (charge(ncent), xyz(ncent,3), atnam(ncent), stat=ier)
      if (ier.ne.0)
     & call error ('datarholm', 'Cannot  allocate charge and/or xyz 
     & and/or atnam', faterr)
      do ic = 1, ncent
        read (stdin2,102) atnam(ic)(1:4),(xyz(ic,k),k=1,3),charge(ic)
      enddo
      read (stdin2,103) nfun
100   format (11x,a)
101   format (1x,i5,6x,i5,13x,i5)
102   format (1x,a8,16x,3(F12.8),10x,f5.1)
103   format (7x,i8)
c
c.....SYM info
c
 8    read (stdin2, 700) line
      lp = 1
      if (setword(word, line, lp)) then      
       if (word.ne.'Symmetry') goto 8
       continue
      else
       goto 8
      endif 
      read (stdin2,200) nop, neq
      allocate (ineq(neq), stat=ier)
      if (ier.ne.0)
     & call error ('datarholm','Cannot allocate ineq', faterr) 
      if (nop.gt.1) then
        allocate (idx(ncent,2), oper(3,3,nop), stat=ier)
        if (ier.ne.0)
     & call error('datarholm','Cannot allocate idx and/or oper', faterr)
        read (stdin2,201) (ineq(i), i=1,neq)
        read (stdin2,202) (idx(i,1), i=1,ncent)
        read (stdin2,203) (idx(i,2), i=1,ncent)
        do i = 1, nop
          do j = 1, 3
             read (stdin2,204) (oper(j,k,i), k=1,3)
          enddo
        enddo
      else
       do i = 1, neq
        ineq(i) = i
       enddo
      endif
700   format (5x,a)
200   format (1x,i2,9x,i3)
201   format (7x,21(1x,i3))
202   format (8x,21(1x,i3))
203   format (8x,21(1x,i3))
204   format (15x,3(1x,f18.15))
c
c.....ATOM info
c
      read (stdin2,300) itask, rmaxsurf
300   format (26x,i2,7x,1pe22.15)
c
c.....Quadrature info
c
 9    read (stdin2, 700) line
      lp = 1
      if (setword(word, line, lp)) then
       if (word.ne.'Quadrature') goto 9
       continue
      else
       goto 9
      endif
      read (stdin2,400) lmax, leb, iqudt, mapt, mmap, npang
      allocate (ct(npang), st(npang), cp(npang), sp(npang), angw(npang),
     &          stat=ier)
      if (ier.ne.0)
     & call error('datarholm','Cannot allocate ct and/or st and/or cp
     & and/or sp and/or angw', faterr)
      if (.not.leb) read (stdin2,401) nptheta, npphi
      do i = 1, npang
        read (stdin2,402) ct(i),st(i),cp(i),sp(i),angw(i) 
      enddo
      read (stdin2,403) nr, doromberg, iqudr, mapr, alfm, mpr
      allocate (xyzrho(ncent,3), rmesh(0:nr-1,1:neq), 
     &          wrmesh(0:nr-1,1:neq), stat=ier)
      if (ier.ne.0)
     & call error('datarholm','Cannot allocate xyzrho and/or rmesh
     & and/or wrmesh', faterr)
      do i = 1, neq
        ic = ineq(i)
        read (stdin2,404) (xyzrho(ic,j), j=1,3)
        do j = 0, nr-1
          read (stdin2,405) rmesh(j,i), wrmesh(j,i)
        enddo
      enddo
c.....Beta-sphere
      read (stdin2,700) line
      lp = 1
      if (setword(word, line, lp)) then
       if (word.ne.'B-sphere') then
        bsphere = .false. 
        goto 50 
       else
        bsphere = .true.
        read (stdin2, 406) llmax, lebb, npangb
        allocate (ctb(npangb), stb(npangb), cpb(npangb), spb(npangb), 
     &            angwb(npangb), stat=ier)
        if (ier.ne.0)
     &   call error('datarholm','Cannot allocate ctb and/or stb and/or
     & cpb and/or spb and/or angwb', faterr)
        if (.not.lebb) read (stdin2,401) npthetab, npphib
        do i = 1, npangb
         read (stdin2,402) ctb(i),stb(i),cpb(i),spb(i),angwb(i)
        enddo
        read (stdin2,407) nrb,iqudrb,maprb 
        allocate (betrad(ncent), rbet(0:nrb-1,1:neq), 
     &            wrbet(0:nrb-1,1:neq), stat=ier)
        if (ier.ne.0)
     &   call error('datarholm','Cannot allocate betrad and/or rbet
     & and/or wrbet', faterr)
        do i = 1, neq
         ic = ineq(i)
         read (stdin2,408) betrad(ic)
         do j = 0, nrb-1
          read (stdin2,405) rbet(j,i), wrbet(j,i)
         enddo
        enddo
       endif
      else
       bsphere=.false.
       goto 50
      endif 
 50   continue
c  
c.....Obtain new variables
c
      lmax2 = lmax*(lmax+2)
      llmax2 = llmax*(llmax+2)
      lmax21 = lmax2+1
      llmax21 = llmax2+1
      lpmin = min(lmax,llmax)
      lpmax = max(lmax,llmax)

400   format (7x,i2,6x,l1,8x,i2,7x,i2,7x,i2,8x,i7)
401   format (10x,i4,8x,i4)
402   format (23x,4(1x,f18.15),7x,1pe22.15)
403   format (/5x,i7,12x,l1,8x,i2,7x,i2,7x,1pe22.15,6x,i4)
404   format (/17x,3(1x,e22.15)/)
405   format (2(4x,e22.15))
406   format (8x,i2,7x,l1,9x,i7)
407   format (/6x,i7,9x,i2,8x,i2)
408   format (/22x,1pe22.15/)
c
c.....end
c
      return
      end
