      module datos
      implicit real*8 (a-h,o-z)
      save
c
c---- Standard input, output, and error units.
c
      integer, parameter :: stdin1=5,stdin2=6,stdout=31,stdout1=32
c
c----- Error codes.
c 
      integer, parameter :: faterr=-1,warning=1,noerr=0
c
c----- getopt variables.     
c
      integer, parameter :: ilen = 200,marg = 1
      character*(ilen) :: arg(marg) 
      logical :: larg(marg)
      data (larg(i),i=1,marg) /marg*.false./
c
c----- setword variables.
c
      character*(100) :: word
      character*(ilen) :: line 
c
c----- Factorial function variables.
c
      integer :: ntop
      real*8, dimension (:) :: a(33)
      data ntop, a(1) /0,1d0/
c
c----- Sumln function variables.
c
      integer :: sumtop
      real*8, dimension (:) :: lfac(0:100)
      data sumtop, lfac(0) /0,0d0/
c
c----- Main variables of promolden code.
c
      integer :: nr, neq, nop, nfun, lmax,  
     &           nprims, nmo, ncent, itask, iqudt, mapt, mmap, npang,
     &           nptheta, npphi, iqudr, mapr, mpr, llmax, npangb,  
     &           npthetab, npphib, nrb, iqudrb, maprb, 
     &           lmax2, llmax2, lmax21,  llmax21, lpmin, lpmax
      real*8 :: rmaxsurf, alfm
      logical :: doromberg, leb, lebb, bsphere
      integer, allocatable, dimension (:) :: ineq
      integer, allocatable, dimension (:,:) :: idx
      real*8, allocatable, dimension (:) :: charge,ct, st, cp, sp, angw,
     &               ctb, stb, cpb, spb, angwb, betrad
      real*8, allocatable, dimension (:,:) :: xyz, xyzrho, rmesh,
     &               wrmesh, rbet, wrbet
      real*8, allocatable, dimension (:,:,:) :: oper 
      character*(ilen) :: filename 
      character*(4), allocatable, dimension (:) :: atnam
c
c----- Variables of shellrholm subroutine.
c
      character*(ilen) :: fileout
      integer :: nmax, nbmax, npmin, npmax, maxn
      integer :: ltot, ltotm, ntot, maxl
      real*8 :: afactor, t1, t2
      real*8, parameter :: pi=3.14159265358979323846d0 
      logical :: scr, scrb, output, qlm, bqlm, qtot, logfac, qnlm,
     & bqnlm, qntot, logelecME, logelecBE, logautME, logautBE, 
     & logrank, logpade, logautp, logera, logautera, logrotm,
     & lognotel, logshift, logmshift, logmmshift, logmmmshift,
     & logmcshift, logcshift, logconvBE
      data scr,scrb,ouput,qlm,bqlm,qtot,logfac,qnlm,bqnlm,qntot,
     & logelecME,logcelecBE,logautME,logautBE,logrank,
     & logpade,logautp,logera,logautera,logrotm,
     & lognotel,logshift,logmshift,logmmshift,
     & logmmmshift,logmcshift,logcshift,logconvBE /28*.false./ 
c
c----- Variables of calcrho subroutine.
c
       real*8, allocatable, dimension (:,:,:) :: rholm, brholm
c
c----- Variables of calcqlm subroutine.
c
       real*8, allocatable, dimension (:,:) :: rhoqlm, brhoqlm
c
c----- Variables calcqtot subroutine.
c
       real*8, allocatable, dimension (:,:) :: qlmtot
c
c----- Variables calcqnlm subroutine.
c
       real*8, allocatable, dimension (:,:,:) :: rhoqnlm, brhoqnlm
c
c----- Variables calcqnlmtot subroutine.
c
       real*8, allocatable, dimension (:,:,:) :: qnlmtot
c
c----- Variables calcelecME and calcelecBE subroutines.
c
       integer :: neq1, neq2, eq1, eq2 
       real*8 :: VMEP, VMEP2, VMEO, VMEO2, VBE, VBE2,
     & sigm, sigmtot, R, thetaAB, phiAB
       real*8, dimension (3) :: tra, trb
       real*8, dimension (3,3) :: c
       real*8, allocatable, dimension (:,:,:,:) :: TtildaList
       integer, allocatable, dimension (:,:,:,:) :: TtildaLabel 
       real*8, allocatable, dimension (:) :: slm
       integer, allocatable, dimension (:) :: il0
c
c----- Rational approximations variables.
c
       integer :: rank, m, n
       real*8, allocatable, dimension (:) :: cof, coft, cofera, tcheb,
     & gamm
       real*8 :: alpha, resid, numera, denera, enera
c
c----- Shift multipole moments variables.
c
c-------x,y,z=catersian coordinates for the centers
      real*8, dimension (:) :: x(1:4), y(1:4), 
     & z(1:4)
c-------multim=multipole moments for the centers
      real*8, allocatable, dimension (:,:,:,:) ::  multim
c-------convergent=indicate if convergent for Coulomb energy 
c-------have been defined
      logical :: convergent
c-------(mono,b,tr)increment=indicate if increment in
c-------(mono,bi,tri)bidimensional shift have been defined
      logical :: monoincrement, bincrement, trincrement
c-------(mono,bi,tri)min=indicate if initial 
c-------(mono,bi,tri)dimensional shift have been defined
      logical :: monomin, bimin, trimin
c-------(mono,bi,tri)max=indicate if final
c-------(mono,bi,tri)dimensional shift have been defined
      logical :: monomax, bimax, trimax      
c-------Nuclei positions
      integer :: nin
c-------Convergent for Coulomb energy
      real*8 :: convt
c-------Initial and final integers numbers for monodimensional shift
      integer :: mmin, mmax
c-------Initial and final integers numbers for bidimensional shift
      integer :: bmin, bmax
c-------Initial and final integers numbers for tridimensional shift
      integer :: tmin, tmax
c-------Increment in monodimensional shift
      real*8 :: mincrem
c-------Increments in bidimensional shift
      real*8 :: bincrem1, bincrem2
c-------Increments in tridimensional shift
      real*8 :: tincrem1, tincrem2, tincrem3
c-------Denominators in alpha and beta angles       
      integer :: llin1, llin2
c-------Increment in allbishift and alltrishift
      real*8 :: rinc
c-------Initials alpha and beta angles
      real*8 :: alphin, betin
c-------Alpha and beta angles
      real*8 :: alph, bet
c-------Number of shifts
      integer :: jmax
c-------Shift variables
      real*8, allocatable, dimension (:) :: slm2, numbl 
      integer, allocatable, dimension (:) :: il02
c-------Energy variables
      integer, dimension (:) :: test(4)
c
c..... Variables for rotate subroutines.
c
       integer :: maxrotr
       real*8 :: Q22, W
       logical :: logliber
       data logliber /.false./
       real*8, allocatable, dimension (:,:,:) :: rotop
       integer, allocatable, dimension (:) :: irot0
       real*8, allocatable, dimension (:,:) :: rotr
c
      end module datos
