c-----------------------------------------------------------------
      subroutine energy(in) 
c-----------------------------------------------------------------
      use datos, only : stdout1, ltot, test, x, y, z,
     & convt, multim, ltotm, R, thetaAB, phiAB, slm, il0
      use libreria, only : T2, arrayk, itoa, leng, bol, rsh
      implicit real*8 (a-h,o-z)
      integer :: in
c.....LOCAL VARIABLES:
      integer :: la, ka, lb, kb, Lloop
      real*8 :: reslt1, Qa, Qb, Tensor, total, total2
      real*8, dimension (ltot+1,ltot*2+1) :: atomA, atomB
      real*8, dimension (0:ltot+1) :: conv
      real*8, dimension (3) :: coordA, coordB, RAB
      integer :: isite1, isite2, isite3, isite4, itest
      integer :: list1(2), list2(2), list3(2), list4(2), is1, is2
      character*16 :: number
      character*2 :: car(4)


c.....Inizializations and allocations
      list1(1)=1;list1(2)=3 
      list2(1)=2;list2(2)=4  
      list3(1)=1;list3(2)=5
      list4(1)=2;list4(2)=6
      total=0d0;test=0;itest=1


c.....Electrostatic interaction between atoms A and B
      do is1=1,2
       do is2=1,2
c.......New allocation of nuclei coordinates
        isite1=list1(is1)
        isite2=list2(is2)
        isite3=list3(is1)
        isite4=list4(is2)
        coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
        coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c.......New allocation of multipole moments
        do la=0,ltot
         atomA(la+1,1)=multim(isite3,la,0,1)
         do ka=2,2*la+1
          atomA(la+1,ka)=multim(isite3,la,int(ka/2),mod(ka,2)+1)
         enddo
        enddo
        do lb=0,ltot
         atomB(lb+1,1)=multim(isite4,lb,0,1)
         do kb=2,2*lb+1
          atomB(lb+1,kb)=multim(isite4,lb,int(kb/2),mod(kb,2)+1)
         enddo
        enddo
c.......Inizializations for each loop
        reslt1=0d0
        conv=0d0

c.......Calculation of RSHs
        RAB = coordB - coordA
        call bol (RAB,R,thetaAB,phiAB) ! Obtain polar coordinates
        call rsh (thetaAB,phiAB,slm,il0,ltotm) ! Obtain RSHs
c.......ME
        do Lloop=1,ltot+1 
         conv(Lloop)=conv(Lloop-1)
         do la=Lloop-1,0,-1
          lb=Lloop-1-la
          do ka=-la,la
           do kb=-lb,lb
c..........Calculation of Qa*T*Qb
c..........New allocation of multipole moments 
            Qa=AtomA(la+1,arrayk(ka)) !Note: array is a external function
            Qb=AtomB(lb+1,arrayk(kb))
            Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
            reslt1=reslt1+Qa*Tensor*Qb
            conv(Lloop)=conv(Lloop)+Qa*Tensor*Qb
           enddo
          enddo
         enddo
c........Test: if convergence have been found, we truncate
c........the multipole expansion
         if (Lloop.gt.4) then
          if (abs(conv(Lloop)-conv(Lloop-1)).lt.convt.and.
     &        abs(conv(Lloop)-conv(Lloop-2)).lt.convt.and.
     &        abs(conv(Lloop)-conv(Lloop-3)).lt.convt) then
c.............Rank of the expansion
           test(itest)=Lloop
           goto 10
          endif
         endif
        enddo
10      total=total+reslt1
        total2=total*2625.5d0
        itest=itest+1
       enddo
      enddo
c.....Write in outputfile
      do j=1,4
       if (test(j).ne.0) then
        number=itoa(test(j))
        car(j)=number(1:leng(number))
       else
        car(j)='NC'
       endif
      enddo
      write (stdout1,fmt=400) in,car(1),car(4),car(2),car(3),total,
     & total2
c.....Formats
 400  format (1x,i5,14x,a,8x,a,7x,a,12x,a,11x,e23.16,1x,e23.16)
c
      return
      end subroutine  



