c
c-----------------------------------------------------------------------
c
      subroutine mod_cshift ()
c
c.....mod_cshift - shell specialized in ME using shift multipole moments.
c
      use datos, only : stdin1, stdout1, ilen, word, line, neq1,
     &                  neq2, eq1, eq2, neq, ltot, mincrem, 
     &                  monoincrement, mmin, monomin, mmax, monomax, 
     &                  jmax, ltotm, numbl, il0, multim, x, y, z, slm, 
     &                  R, faterr, warning, lpmin, pi
      use libreria, only : setline, leng, setword, setint, setdble, 
     &                     uppcase, bol, rsh2, calc_tnewmm, arrayk, T2,
     &                     error, equiv
      implicit real*8 (a-h,o-z)
c.....LOCAL VARIABLES
      logical ::          ok, done, outname, logneq, logtot,
     &                    logener
      character*(ilen) :: word2, fileshift
      integer ::          is1, is2
      integer ::          isite1, isite2, isite3, isite4
      integer ::          list1(2), list2(2), list3(2), list4(2)
      real*8 ::           rab(3), u(3)
      real*8, allocatable, dimension (:) ::     rshift, accex
      real*8, allocatable, dimension (:,:) ::   accume, accume2
      real*8, allocatable, dimension (:,:) ::   etrunc, energ, eredon
      real*8, allocatable, dimension (:,:,:) ::   atomA, atomB
      real*8, allocatable, dimension (:,:,:) :: oldmm, newmm
      real*8, allocatable, dimension (:,:,:,:,:) :: Qout1, Qout2
      real*8 ::          tin, tfin
      real*8 ::          rcart(3), rcart2(3,2)
      real*8 ::          rad, theta, phi
      real*8 ::          coordA(3), coordB(3)
      real*8 ::          Rtmp(2,2), thetmp(2,2), phitmp(2,2)
      real*8 ::          Qa, Qb, Tensor, eexact
      real*8, parameter :: TINY = 1d-20
c
c.....initialize variables :
c
      monoincrement = .false.
      monomin       = .false.
      monomax       = .false.
      logneq        = .false.
      logltot       = .false.
      outname       = .false.
      logener       = .false.
      write (stdout1,600)
c
c.....read input orders:
c
      done = .false.
      do while (.not. done)
         if (.not. setline (stdin1, line, lp)) then
            call error ('mod_cshift', 'premature end of data', warning)
            return
         endif
         ll = leng(line)
         if (.not. setword (word2, line, lp)) then
            call error ('mod_cshift', 'premature end of line', warning)
            return
         endif
         word = uppcase (word2)
         lw = leng(word)
         ok = .false.
c
c........case sentences to interpret word:
c
         if (word(1:1) .eq. '#' .or. word(1:lw) .eq. 'REM') then
c
c...........skip comment lines:
c
            ok = .true.
c
         else if (word(1:lw) .eq. 'NEQ') then
            ok = setint (eq1, line, lp)
            ok = ok .and. setint (eq2, line, lp)
            ok = ok .and. equiv(eq1,neq1) .and. equiv(eq2,neq2)
            logneq = ok
c
         else if (word(1:lw) .eq. 'ENERGY') then
            ok = setdble (eexact, line, lp)
            logener = ok
c
         else if (word(1:lw) .eq. 'LTOT') then
            ok = setint (ltot, line, lp)
            ok = ok .and. ltot.ge.0
            ok = ok .and. ltot.le.lpmin
            logltot = ok
c
         else if (word(1:lw) .eq. 'MONOINCREMENT') then
            ok = setdble (mincrem, line, lp)
            ok = ok .and. mincrem.gt.0d0
            monoincrement = ok
c
         else if (word(1:lw) .eq. 'MONOMIN') then
            ok = setint(mmin, line, lp)
            ok = ok .and. mmin.ge.0
            monomin = ok
c
         else if (word(1:lw) .eq. 'MONOMAX') then
            ok = setint(mmax, line, lp)
            ok = ok .and. mmax.ge.0
            monomax = ok
c
         else if (word(1:lw) .eq. 'OUTPUTNAME') then
            ok = setword(word2, line, lp)
            fileshift = word2(1:leng(word2))
            outname = ok
c
         else if (word(1:lw) .eq. 'ENDCSHIFT') then
            done = .true.
            ok = .true.
c
         else
            ok = .false.
         endif
c
c........trap lecture errors:
c
         if (.not. ok) then
            call error ('mod_cshift', 'order not recognized: '//
     &                  line(1:ll), faterr)
         endif
      enddo
      if (.not.logneq)
     &  call error ('mod_cshift', 'neq1 and neq2 have not been'//
     &                            ' defined', faterr)
      if (.not.logltot)
     &  call error ('mod_cshift', 'ltot has not been defined',
     &              faterr)
      if (.not.monoincrement)
     &  call error ('mod_cshift', 'increment has not been defined',
     &              faterr)
      if (.not.monomin)
     &  call error ('mod_cshift', 'initial shift has not been defined',
     &              faterr)
      if (.not.monomax)
     &  call error ('mod_cshift', 'maximum shift has not been defined',
     &              faterr)
      if (.not.outname)
     &  call error ('mod_cshift', 'fileshift has not been defined',
     &              faterr)
      if (.not.logener)
     &  call error ('mod_cshift', 'exact energy has not been defined',
     &              faterr)
      if (mmin.ge.mmax)
     &  call error ('mod_cshift', 'mmin is greather than or equal'//
     &              ' to mmax', faterr)
      jmax = mmax - mmin + 1 ! jmax -> number of shifts
c
c.....BEGIN THE RUN:
c
c.....(A): Allocations and initializations:
c
      ltotm = ltot + ltot
      allocate (il0(0:ltotm), stat=ier)
      if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot allocate il0', faterr)
      allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
      if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot allocate slm', faterr)
      allocate (multim(1:6,0:ltot,0:ltot,1:2), stat=ier)
      if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot allocate multim',
     &               faterr)
      allocate (numbl(0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot allocate numbl', faterr)
      allocate (accex(0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot allocate accex', faterr)  
      allocate (accume(1:jmax,0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_cshift', 'Cannot allocate accume', faterr)
       allocate (accume2(1:jmax,0:ltot), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate accume2', faterr)
       allocate (Qout1(2,1:jmax,0:ltot,0:ltot,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate Qout1', faterr)
       allocate (Qout2(2,1:jmax,0:ltot,0:ltot,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate Qout2', faterr)
       allocate (rshift(1:jmax), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate rshift', faterr)
       allocate (etrunc(1:jmax,1:ltot),stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate etrunc', faterr)
       allocate (energ(1:jmax,1:ltot),stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate energ', faterr)
       allocate (eredon(1:jmax,1:ltot),stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate eredon', faterr)
       allocate (oldmm(0:ltot,0:ltot,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate oldmm', faterr)
       allocate (newmm(0:ltot,0:ltot,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate newmm', faterr)
       allocate (atomA(ltot+1,ltot+ltot+1,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate atomA', faterr)
       allocate (atomB(ltot+1,ltot+ltot+1,2), stat=ier)
       if (ier.ne.0)
     &   call error ('mod_cshift', 'Cannot allocate atomB', faterr)
c......Initializations
       list1(1)=1;list1(2)=3 ! nuclei positions (atomA)
       list2(1)=2;list2(2)=4 ! nuclei positions (atomB)
       list3(1)=1;list3(2)=5 ! OUT shift mulitpole moments (atomA)
       list4(1)=2;list4(2)=6 ! OUT shift mulitpole moments (atomB)
c......Obtain Normalization coefficients
       do l = 0, ltot
         cte = 4d0*pi/(2d0*l+1d0)
         numbl(l) = sqrt(cte)
       enddo
c......Compute il0 indice to accede in slm supervectors
       il0(0) = 0
       il = 0
       do l = 1, ltotm
         il = il + l + l
         il0(l) = il
       enddo
       call cpu_time(tin)
c
c.....(B): Compute both Beta and Out multipole moments for neq1 and
c          neq2 inequivalent topological atoms:
c
      call read_multipole()
c
c.....(C): From ME, calculate the Coulomb interactions between
c          topological atoms using original multipole moments:
      x(3) = x(1)
      y(3) = y(1)
      z(3) = z(1)
      x(4) = x(2)
      y(4) = y(2)
      z(4) = z(2)
      do nin = 1, 2
c     nin = 1 <-> atom A ; nin = 2 <-> atomB
        do l = 0, ltot
          do m = 0, l
            if (m.eq.0) then
              imax = 1
            else
              imax = 2
            endif
            do i = 1, imax
              multim(nin+4,l,m,i) = multim(nin+2,l,m,i)
            enddo
          enddo
        enddo
      enddo
      do is1 = 1, 2
        do is2 = 1, 2
c.........New allocation of nuclei coordinates
          isite1 = list1(is1)
          isite2 = list2(is2)
          coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
          coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c.........Calculation of polar coordinates using in ME tensor
          rab = coordB - coordA
          call bol(rab,rad,theta,phi)
          Rtmp(is1,is2) = rad
          thetmp(is1,is2) = theta
          phitmp(is1,is2) = phi
c.........New allocation of multipole moments
          isite3 = list3(is1)
          isite4 = list4(is2)
          do l = 0, ltot
            atomA(l+1,1,is1)=multim(isite3,l,0,1)
            atomB(l+1,1,is2)=multim(isite4,l,0,1)
            do k = 2, l+l+1
              atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
              atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
            enddo
          enddo
        enddo ! is2
      enddo ! is1
c.....ME
      do l = 0, ltot
        accex(l)=0d0
        do is1 = 1, 2
          do is2 = 1, 2
c...........Recover polar coordinates using in ME tensor
            R = Rtmp(is1,is2)
            theta = thetmp(is1,is2)
            phi = phitmp(is1,is2)
c...........Obtain RSHs using in ME tensor
            call rsh2(theta,phi,slm,il0,l+l)
            do la= 0, l
              do lb= 0, l
                do ka=-la,la
                  do kb=-lb,lb
c...................Calculation of Qa*T*Qb
                    Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                    Qb=AtomB(lb+1,arrayk(kb),is2)
                    Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                    accex(l)=accex(l)+Qa*Tensor*Qb
                  enddo
                enddo
              enddo
            enddo
          enddo ! is2
        enddo ! is1
      enddo ! l
c
c.....(D): From ME, calculate the Coulomb interactions between
c          topological atoms using shift out betasphere multipole
c          moments:
c

c.....Obtain the vector linking the nuclei A and B
      rab(1) = x(2) - x(1)
      rab(2) = y(2) - y(1)
      rab(3) = z(2) - z(1)
c.....Unitary vector "u" in the direction linking the nuclei
      u = rab/sqrt(dot_product(rab,rab))
      j = 0
      do ishift = mmin, mmax ! Shift multipole moments
        j = j + 1
        temp = mincrem*ishift
        rshift(j) = temp ! shift
c.....(D1): Calculate new centers for the out betasphere
c           multipole moments. Atom B shifts in the direction 
c           of the vector shift, but atom A shifts in the
c           opposite direction:
        x(3) = x(1) - u(1)*temp
        y(3) = y(1) - u(2)*temp
        z(3) = z(1) - u(3)*temp
        x(4) = x(2) + u(1)*temp
        y(4) = y(2) + u(2)*temp
        z(4) = z(2) + u(3)*temp
c.....(D2): Obtain the shift out betasphere multipole moments:
        do nin = 1, 2
c       nin = 1 <-> atom A ; nin = 2 <-> atomB
          do l = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                oldmm(l,m,i) = multim(nin+2,l,m,i)
                Qout1(nin,j,l,m,i) = multim(nin+2,l,m,i)
              enddo
            enddo
          enddo
c.........Obtain the shift vector
          rcart2(1,nin)=x(nin)-x(nin+2)
          rcart2(2,nin)=y(nin)-y(nin+2)
          rcart2(3,nin)=z(nin)-z(nin+2)
          do i = 1, 3
            rcart(i) = rcart2(i,nin)
          enddo
c.........Transform the cartesians coordinates of shift vector to polar 
c         spherical coordinates and obtain new multipole moments for
c         OUT(A) or OUT(B)
          call bol(rcart,rad,theta,phi)
          call rsh2(theta,phi,slm,il0,ltot) ! Obtain RSHs
          call calc_tnewmm(newmm,oldmm,rad,ltot)
c.........Reallocation of shift multipole moments
          do l = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                multim(nin+4,l,m,i) = newmm(l,m,i)
              enddo
            enddo
          enddo
        enddo ! nin
c.....(D3): Calculate Coulomb interactions between atoms A and B
c           using ME:
        do is1 = 1, 2
          do is2 = 1, 2
c...........New allocation of nuclei coordinates
            isite1 = list1(is1)
            isite2 = list2(is2)
            coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
            coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c...........Calculation of polar coordinates using in ME tensor
            rab = coordB - coordA
            call bol(rab,rad,theta,phi)
            Rtmp(is1,is2) = rad
            thetmp(is1,is2) = theta
            phitmp(is1,is2) = phi
c...........New allocation of multipole moments
            isite3 = list3(is1)
            isite4 = list4(is2)
            do l = 0, ltot
              atomA(l+1,1,is1)=multim(isite3,l,0,1)
              atomB(l+1,1,is2)=multim(isite4,l,0,1)
              do k = 2, l+l+1
                atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
                atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
              enddo
            enddo
          enddo ! is2
        enddo ! is1
c.......ME
        do l = 0, ltot
          accume(j,l)=0d0
          do is1 = 1, 2
            do is2 = 1, 2
c.............Recover polar coordinates using in ME tensor
              R = Rtmp(is1,is2)
              theta = thetmp(is1,is2)
              phi = phitmp(is1,is2)
c.............Obtain RSHs using in ME tensor
              call rsh2(theta,phi,slm,il0,l+l)
              do la= 0, l
                do lb= 0, l
                  do ka=-la,la
                    do kb=-lb,lb
c.....................Calculation of Qa*T*Qb
                      Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                      Qb=AtomB(lb+1,arrayk(kb),is2)
                      Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                      accume(j,l)=accume(j,l)+Qa*Tensor*Qb
                    enddo
                  enddo
                enddo
              enddo
            enddo ! is2
          enddo ! is1
        enddo ! l
c....(D4): Obtain out betasphere multipoles in the origin using  
c          shift multipole moments:   
        x(3) = x(1)
        y(3) = y(1)
        z(3) = z(1)
        x(4) = x(2)
        y(4) = y(2)
        z(4) = z(2)
        do nin = 1, 2
c          nin = 1 <-> atomA : nin = 2 <-> atomB
          do l  = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                oldmm(l,m,i) = multim(nin+4,l,m,i)
              enddo
            enddo
          enddo
c.........Obtain the original nuclei positions
          do i = 1, 3
            rcart(i) = - rcart2(i,nin)
          enddo
c.........Transform the cartesians coordinates of shift vector to polar
c         spherical coordinates and obtain new multipole moments for
c         OUT(A) or OUT(B)
          call bol(rcart,rad,theta,phi)
          call rsh2(theta,phi,slm,il0,ltot) ! Obtain RSHs
          call calc_tnewmm(newmm,oldmm,rad,ltot)
c.........Reallocation of shift multipole moment
          do l = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                multim(nin+4,l,m,i) = newmm(l,m,i)
                Qout2(nin,j,l,m,i) = newmm(l,m,i)
              enddo
            enddo
          enddo
        enddo ! nin
c.....(D5): Calculate Coulomb interactions between atoms A and B
c           using ME:
        do is1 = 1, 2
          do is2 = 1, 2
c...........New allocation of nuclei coordinates
            isite1 = list1(is1)
            isite2 = list2(is2)
            coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
            coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c...........Calculation of polar coordinates using in ME tensor
            rab = coordB - coordA
            call bol(rab,rad,theta,phi)
            Rtmp(is1,is2) = rad
            thetmp(is1,is2) = theta
            phitmp(is1,is2) = phi
c...........New allocation of multipole moments
            isite3 = list3(is1)
            isite4 = list4(is2)
            do l = 0, ltot
              atomA(l+1,1,is1)=multim(isite3,l,0,1)
              atomB(l+1,1,is2)=multim(isite4,l,0,1)
              do k = 2, l+l+1
                atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
                atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
              enddo
            enddo
          enddo ! is2
        enddo ! is1
c.......ME
        do l = 0, ltot
          accume2(j,l)=0d0
          do is1 = 1, 2
            do is2 = 1, 2
c.............Recover polar coordinates using in ME tensor
              R = Rtmp(is1,is2)
              theta = thetmp(is1,is2)
              phi = phitmp(is1,is2)
c.............Obtain RSHs using in ME tensor
              call rsh2(theta,phi,slm,il0,l+l)
              do la= 0, l
                do lb= 0, l
                  do ka=-la,la
                    do kb=-lb,lb
c.....................Calculation of Qa*T*Qb
                      Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                      Qb=AtomB(lb+1,arrayk(kb),is2)
                      Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                      accume2(j,l)=accume2(j,l)+Qa*Tensor*Qb
                    enddo
                  enddo
                enddo
              enddo
            enddo ! is2
          enddo ! is1
        enddo ! l
c.....(D6): Calculate the energy error, truncation error and
c           shift error:
        do l = 1, ltot
          energ(j,l) = accume(j,l) - eexact
          etrunc(j,l) = accume(j,l) - accume(j,l-1)
          eredon(j,l) = accume2(j,l) - accex(l)
        enddo
      enddo ! ishift
      call cpu_time(tfin)
c 
c.....(E): Write fileshift:
c
      open (8,file=fileshift(1:leng(fileshift)), status='unknown',
     &         iostat=nios)
      if (nios.ne.0)
     & call error ('mod_cshift', 'error while opening '//
     & fileshift(1:leng(fileshift)), faterr)
      do nin = 1, 2
        if (nin.eq.1) then
          write (8,fmt=300) neq1
        else
          write (8,fmt=300) neq2
        endif
        do j = 1, jmax
          do l = 0, ltot
            do k = 0, l               
              if (k.eq.0) then 
                Qor = Qout1(nin,j,l,k,1)
                Qrs = Qout2(nin,j,l,k,1)
                aerr = abs(Qrs-Qor)
                if (abs(Qor).gt.TINY) then
                  rerr = aerr / abs(Qor)
                  write (8,fmt=400) rshift(j), l, k, Qor, Qrs,
     &                              aerr, rerr
                else
                  write (8,fmt=500) rshift(j), l, k, Qor, Qrs,
     &                              aerr, 'NC'
                endif
              else
                Qor = Qout1(nin,j,l,k,2)
                Qrs = Qout2(nin,j,l,k,2)
                aerr = abs(Qrs-Qor)
                if (abs(Qor).gt.TINY) then
                  rerr = aerr / abs(Qor)
                  write (8,fmt=400) rshift(j), l, -k, Qor, Qrs,
     &                               aerr, rerr
                else
                  write (8,fmt=500) rshift(j), l, -k, Qor, Qrs,
     &                               aerr, 'NC'
                endif
                Qor = Qout1(nin,j,l,k,1)
                Qrs = Qout2(nin,j,l,k,1)
                aerr = abs(Qrs-Qor)
                if (abs(Qor).gt.TINY) then
                  rerr = aerr / abs(Qor)
                  write (8,fmt=400) rshift(j), l, k, Qor, Qrs,
     &                              aerr, rerr
                else
                  write (8,fmt=500) rshift(j), l, k, Qor, Qrs,
     &                              aerr, 'NC'
                endif
              endif
            enddo
          enddo
        enddo
      enddo
      close (8)
c
c.....(F): Print of results:
c
      write (stdout1,fmt=800) ltot, eexact, neq1, neq2
      write (stdout1, fmt=100)
      do l = 1, ltot
        do j = 1, jmax
            write (stdout1, fmt=200) l, rshift(j), energ(j,l),
     &                               etrunc(j,l), eredon(j,l)
        enddo
      enddo
      write (stdout1,700) tfin-tin
c
c.....(G): Deallocations:
c
      deallocate (slm, il0, multim, numbl, accex, stat=ier)
      if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0 and/or multim and/or numbl and/or accex', faterr)
      deallocate (accume, accume2, stat=ier)
      if (ier.ne.0)
     & call error ('mod_cshift', 'Cannot deallocate accume and/
     &or accume2', faterr)
      deallocate (Qout1, Qout2, stat=ier)
      if (ier.ne.0)
     &  call error ('mod_cshift', 'Cannot deallocate Qout1 and/
     &or Qout2', faterr)
      deallocate (rshift, etrunc, energ, eredon, stat=ier)
      if (ier.ne.0)
     & call error ('mod_cshift', 'Cannot deallocate rshift and/or
     & etrunc and/or energ and/or eredon', faterr)
      deallocate (oldmm, newmm, stat=ier)
      if (ier.ne.0)
     & call error ('mod_cshift', 'Cannot deallocate oldmm and/or
     & newmm', faterr)
      deallocate (atomA, atomB, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mchift', 'Cannot deallocate atomA and/or
     & atomB', faterr)
c
c.....(H) end-of-comparative shift-run.
c

      write (stdout1,900)
      return
c
 600  format (/
     & 1x, '******************************************************'/
     & 1x, '**      - RHOLM: COMPARATIVE SHIT MODULE -          **'/
     & 1x, '**       (c) C.J.F Solano.  June 3, 2008            **'/
     & 1x, '******************************************************'// )
 100  format (3x,'L',6x,'SHIFT (bohr)',
     &        1x,'Eenerg(SHIFT,L) (hartree)',
     &        1x,'Etrunc(SHIFT,L) (hartree)',
     &        1x,'Eredon(SHIFT,L) (hartree)')
 200  format (1x,i3,1x,f12.5,1x,e23.15,1x,e23.15,1x,e23.15)
 300  format (1x,'COMPARATIVE SHIFT MODULE: MULTIPOLE MOMENTS
     & FOR ATOM ',i5,/,
     &        1x,'SHIFT (bohr)',4x,'L',4x,'M',
     &        1x,'Qout (original)',
     &        9x,'Qout (reshift)',
     &        10x,'ABS. ERROR',
     &        14x,'REL. ERROR')
 400  format (1x,f12.5,1x,i5,1x,i5,1x,e23.15,1x,e23.15,1x,e23.15,
     &        1x,e23.15)
 500  format (1x,f12.5,1x,i5,1x,i5,1x,e23.15,1x,e23.15,1x,e23.15,
     &        1x,a2)
 800  format (1x,'*** 0 <= L <= ',i5,1x,'Eexact = ',e23.16/,
     &        1x,'*** TOPOLOGICAL ATOMS',1x,i5,1x,'AND',1x,i5)
 700  format (1x,'*** TIME COMPUTATION ',f12.5,1x,'SECONDS')
 900  format (/1x, '*** END OF COMPARATIVE SHIT RUN ******************')
      end
