c---------------------------------------------------------------------------
      subroutine mod_elecBE (numb)
c---------------------------------------------------------------------------
      use datos, only : il0, slm, eq1, eq2, ntot, ltot, ltotm,
     & maxl, maxn, t1, t2, stdout1, faterr, convt
      use libreria, only : error
      implicit real*8 (a-h,o-z)
      integer :: numb

c     "calcelecBE" order (numb=1)
      if (numb.eq.1) then
       ltotm = 2*ltot
       allocate (il0(0:ltotm), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_elecBE', 'Can not allocate il0', faterr)
       allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_elecBE', 'Can not allocate slm', faterr)    
        write (stdout1, fmt=100) eq1, eq2
       call cpu_time (t1)
       call calcelecBE ()
       call cpu_time (t2)
       deallocate (slm, il0, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0', faterr)
       call write_elecBE (numb) 
c     "autcalcBE" order (numb=2)
      else if (numb.eq.2) then 
       write (stdout1, fmt=200) eq1, eq2
       do ntot = 0, maxn
        do ltot = 0, maxl
         ltotm=2*ltot
         allocate (il0(0:ltotm), stat=ier)
         if (ier.ne.0)
     &    call error ('shellrholm', 'Can not allocate il0', faterr)
         allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
         if (ier.ne.0)
     &    call error ('shellrholm', 'Can not allocate slm', faterr)
         call cpu_time (t1)
         call calcelecBE ()
         call cpu_time (t2)
         deallocate (slm, il0, stat=ier)
         if (ier.ne.0)
     &    call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0', faterr)
         call write_elecBE (numb)
        enddo
       enddo
c     "convelecBE" order (numb=3)
      else if (numb.eq.3) then
       ltotm = 2*ltot
       allocate (il0(0:ltotm), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_elecBE', 'Can not allocate il0', faterr)
       allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_elecBE', 'Can not allocate slm', faterr)
        write (stdout1, fmt=300) eq1, eq2
        write (stdout1, fmt=400) convt, ntot, ltot
       call cpu_time (t1)
       call calcelecBE2 ()
       call cpu_time (t2)
       deallocate (slm, il0, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0', faterr)
       write (stdout1, fmt=500) t2-t1
      endif
c
c-----Formats
c
 100  format ('Vee(BE) BETWEEN TWO TOPOLOGICAL ATOMS:',/,'PUNTUAL
     & CALCULATION BETWEEN',1x,i5,1x,'AND',1x,i5,1x,'TOPOLOGICAL
     & ATOMS')
 200  format ('Vee(BE) BETWEEN TWO TOPOLOGICAL ATOMS:',/,'ALL
     & CALCULATIONS BETWEEN',1x,i5,1x,'AND',1x,i5,1x,'TOPOLOGICAL ATOMS'
     & ,/,2x,'NTOT',2x,'LTOT',2x,'Vee(BE) (a.u)',12x,'Vee(BE) (kJ/mol)')
 300  format ('Vee(BE) BETWEEN TWO TOPOLOGICAL ATOMS:',/,
     & 'CALCULATION UNTIL CONVERGENCE BETWEEN',1x,i5,1x,'AND',1x,i5,
     & 1x,'TOPOLOGICAL ATOMS')
 400  format ('CONVERGENCE CRITERIA (u.a)=',1x,f10.6,/,'NTOT =',1x,
     & i5,1x,'LTOT =',1x,i5,/,'RANK N',1x,'Vee(BE) (u.a)',11x,
     & 'Vee(BE) (kJ/mol)')
 500  format ('TIME COMPUTATION =',1x,e23.16,1x,'SECONDS')
c
c-----End of the subroutine
c
      return
      end subroutine
