c
c-----------------------------------------------------------------------
c
      subroutine mod_mmmshift ()
c
c.....mod_mmmshift - shell specialized in ME using shift multipole moments.
c
      use datos, only : stdin1, stdout1, ilen, word, line, neq1,
     &                  neq2, eq1, eq2, neq, ltot, mincrem, 
     &                  monoincrement, mmin, monomin, mmax, monomax, 
     &                  jmax, ltotm, numbl, il0, multim, x, y, z, slm, 
     &                  R, faterr, warning, lpmin, pi
      use libreria, only : setline, leng, setword, setint, setdble,
     &                     uppcase, bol, rsh2, calc_tnewmm, arrayk, T2,
     &                     error, sortrx, equiv
      implicit real*8 (a-h,o-z)
c.....LOCAL VARIABLES
      logical ::          ok, done, logneq, logltot 
      character*(ilen) :: word2
      integer ::          is1, is2
      integer ::          isite1, isite2, isite3, isite4
      integer ::          list1(2), list2(2), list3(2), list4(2)
      real*8 ::           rab(3), u(3)
      integer, allocatable, dimension (:) ::    iord, imx 
      integer, allocatable, dimension (:,:) ::  vecmin  
      real*8, allocatable, dimension (:) ::     rshift, accex, ordm
      real*8, allocatable, dimension (:,:) ::   accume, accume2
      real*8, allocatable, dimension (:,:) ::   etrunc, eredon, err
      real*8, allocatable, dimension (:,:,:) :: atomA, atomB
      real*8, allocatable, dimension (:,:,:) :: oldmm1, newmm1, newmm2,
     &                                          devlki
      real*8 ::          tin, tfin
      real*8 ::          rcart(3), rcart2(3,2)
      real*8 ::          rad, theta, phi
      real*8 ::          coordA(3), coordB(3)
      real*8 ::          Rtmp(2,2), thetmp(2,2), phitmp(2,2)
      real*8 ::          Qa, Qb, Tensor
      real*8, parameter :: TINY = 1d-20
      real*8, parameter :: EPSFRAC = 1d-6
c
c.....initialize variables :
c
      monoincrement = .false.
      monomin       = .false.
      monomax       = .false.
      logneq        = .false.
      logltot       = .false.
      write (stdout1,100)
c
c.....read input orders:
c
      done = .false.
      do while (.not. done)
         if (.not. setline (stdin1, line, lp)) then
            call error ('mod_mmmshift', 'premature end of data',
     &                   warning)
            return
         endif
         ll = leng(line)
         if (.not. setword (word2, line, lp)) then
            call error ('mod_mmmshift', 'premature end of line',
     &                   warning)
            return
         endif
         word = uppcase (word2)
         lw = leng(word)
         ok = .false.
c
c........case sentences to interpret word:
c
         if (word(1:1) .eq. '#' .or. word(1:lw) .eq. 'REM') then
c
c...........skip comment lines:
c
            ok = .true.
c
         else if (word(1:lw) .eq. 'NEQ') then
            ok = setint (eq1, line, lp)
            ok = ok .and. setint (eq2, line, lp)
            ok = ok .and. equiv(eq1,neq1) .and. equiv(eq2,neq2)
            logneq = ok
c
         else if (word(1:lw) .eq. 'LTOT') then
            ok = setint (ltot, line, lp)
            ok = ok .and. ltot.ge.0
            ok = ok .and. ltot.le.lpmin
            logltot = ok
c
         else if (word(1:lw) .eq. 'MONOINCREMENT') then
            ok = setdble (mincrem, line, lp)
            ok = ok .and. mincrem.gt.0d0
            monoincrement = ok
c
         else if (word(1:lw) .eq. 'MONOMIN') then
            ok = setint(mmin, line, lp)
            ok = ok .and. mmin.ge.0
            monomin = ok
c
         else if (word(1:lw) .eq. 'MONOMAX') then
            ok = setint(mmax, line, lp)
            ok = ok .and. mmax.ge.0
            monomax = ok
c
         else if (word(1:lw) .eq. 'ENDMSHIFT') then
            done = .true.
            ok = .true.
c
         else
            ok = .false.
         endif
c
c........trap lecture errors:
c
         if (.not. ok) then
            call error ('mod_mmmshift', 'order not recognized: '//
     &                  line(1:ll), faterr)
         endif
      enddo
      if (.not.logneq)
     &  call error ('mod_mmmshift', 'neq1 and neq2 have not been'//
     &                            ' defined', faterr)
      if (.not.logltot)
     &  call error ('mod_mmmshift', 'ltot has not been defined',
     &              faterr)
      if (.not.monoincrement)
     &  call error ('mod_mmmshift', 'increment has not been defined',
     &              faterr)
      if (.not.monomin)
     &  call error ('mod_mmmshift','initial shift has not been defined',
     &              faterr)
      if (.not.monomax)
     &  call error ('mod_mmmshift','maximum shift has not been defined',
     &              faterr)
      if (mmin.ge.mmax)
     &  call error ('mod_mmmshift', 'mmin is greather than or equal'//
     &              ' to mmax', faterr)
      jmax = mmax - mmin + 1 ! jmax -> number of shifts
c
c.....BEGIN THE RUN:
c
c.....(A): Allocations and initializations:
c
      ltotm = ltot + ltot
      allocate (il0(0:ltotm), stat=ier)
      if (ier.ne.0)
     &   call error ('mod_mmmshift', 'Cannot allocate il0', faterr)
      allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate slm', faterr)
      allocate (multim(1:6,0:ltot,0:ltot,1:2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate multim',
     &               faterr)
      allocate (numbl(0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate numbl', faterr)
      allocate (accex(0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate accex', faterr)
      allocate (accume(1:jmax,0:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate accume', faterr)
       allocate (accume2(1:jmax,0:ltot), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate accume2', faterr)
      allocate (rshift(1:jmax), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate rshift', faterr)
      allocate (ordm(1:jmax-2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate ordm', faterr)
      allocate (iord(1:jmax-2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate iord', faterr)
      allocate (imx(1:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate imx', faterr)
      allocate (etrunc(1:jmax,1:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate etrunc', faterr)
      allocate (eredon(1:jmax,1:ltot),stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate eredon', faterr)
      allocate (err(1:jmax,1:ltot),stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate err', faterr)
      allocate (vecmin(1:jmax-2,1:ltot), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate vecmin', faterr)
      allocate (oldmm1(0:ltot,0:ltot,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate oldmm1', faterr)
      allocate (newmm1(0:ltot,0:ltot,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate newmm1', faterr)
      allocate (newmm2(0:ltot,0:ltot,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate newmm2', faterr)
      allocate (devlki(0:ltot,0:ltot,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate devlki', faterr)
      allocate (atomA(ltot+1,ltot+ltot+1,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate atomA', faterr)
      allocate (atomB(ltot+1,ltot+ltot+1,2), stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot allocate atomB', faterr)
c.....Initializations
      imx=0
      list1(1)=1;list1(2)=3 ! nuclei positions (atomA)
      list2(1)=2;list2(2)=4 ! nuclei positions (atomB)
      list3(1)=1;list3(2)=5 ! OUT shift mulitpole moments (atomA)
      list4(1)=2;list4(2)=6 ! OUT shift mulitpole moments (atomB)
c.....Obtain normalization coefficients
      do l = 0, ltot
        cte = 4d0*pi/(2d0*l+1d0)
        numbl(l) = sqrt(cte)
      enddo
c.....Compute il0 indice to accede in slm supervectors
      il0(0) = 0
      il = 0
      do l = 1, ltotm
        il = il + l + l
        il0(l) = il
      enddo      
      call cpu_time(tin)
c
c.....(B): Compute both Beta and Out multipole moments for neq1 and
c          neq2 inequivalent topological atoms:
c
      call read_multipole()
c
c.....(C): From ME, calculate the Coulomb interactions between
c          topological atoms using original multipole moments:
      x(3) = x(1)
      y(3) = y(1)
      z(3) = z(1)
      x(4) = x(2)
      y(4) = y(2)
      z(4) = z(2)
      do nin = 1, 2
c     nin = 1 <-> atom A ; nin = 2 <-> atomB
        do l = 0, ltot
          do m = 0, l
            if (m.eq.0) then
              imax = 1
            else
              imax = 2
            endif
            do i = 1, imax
              multim(nin+4,l,m,i) = multim(nin+2,l,m,i)
            enddo
          enddo
        enddo
      enddo
      do is1 = 1, 2
        do is2 = 1, 2
c.........New allocation of nuclei coordinates
          isite1 = list1(is1)
          isite2 = list2(is2)
          coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
          coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c.........Calculation of polar coordinates using in ME tensor
          rab = coordB - coordA
          call bol(rab,rad,theta,phi)
          Rtmp(is1,is2) = rad
          thetmp(is1,is2) = theta
          phitmp(is1,is2) = phi
c.........New allocation of multipole moments
          isite3 = list3(is1)
          isite4 = list4(is2)
          do l = 0, ltot
            atomA(l+1,1,is1)=multim(isite3,l,0,1)
            atomB(l+1,1,is2)=multim(isite4,l,0,1)
            do k = 2, l+l+1
              atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
              atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
            enddo
          enddo
        enddo ! is2
      enddo ! is1
c.....ME
      do l = 0, ltot
        accex(l)=0d0
        do is1 = 1, 2
          do is2 = 1, 2
c...........Recover polar coordinates using in ME tensor
            R = Rtmp(is1,is2)
            theta = thetmp(is1,is2)
            phi = phitmp(is1,is2)
c...........Obtain RSHs using in ME tensor
            call rsh2(theta,phi,slm,il0,l+l)
            do la= 0, l
              do lb= 0, l
                do ka=-la,la
                  do kb=-lb,lb
c...................Calculation of Qa*T*Qb
                    Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                    Qb=AtomB(lb+1,arrayk(kb),is2)
                    Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                    accex(l)=accex(l)+Qa*Tensor*Qb
                  enddo
                enddo
              enddo
            enddo
          enddo ! is2
        enddo ! is1
      enddo ! l
c
c.....(D): From ME, calculate the Coulomb interactions between
c          topological atoms using shift out betasphere multipole
c          moments:
c

c.....Obtain the vector linking the nuclei A and B
      rab(1) = x(2) - x(1)
      rab(2) = y(2) - y(1)
      rab(3) = z(2) - z(1)
c.....Unitary vector "u" in the direction linking the nuclei
      u = rab/sqrt(dot_product(rab,rab))
      j = 0
      do ishift = mmin, mmax ! Shift multipole moments
        j = j + 1
        temp = mincrem*ishift
        rshift(j) = temp ! shift
c.....(D1): Calculate new centers for the out betasphere
c           multipole moments. Atom B shifts in the direction 
c           of the vector shift, but atom A shifts in the
c           opposite direction:
        x(3) = x(1) - u(1)*temp
        y(3) = y(1) - u(2)*temp
        z(3) = z(1) - u(3)*temp
        x(4) = x(2) + u(1)*temp
        y(4) = y(2) + u(2)*temp
        z(4) = z(2) + u(3)*temp
c.....(D2): Obtain the shift out betasphere multipole moments:
        do nin = 1, 2
c       nin = 1 <-> atom A ; nin = 2 <-> atomB
          do l = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                devlki(l,m,i)=0d0
                oldmm1(l,m,i) = multim(nin+2,l,m,i)
              enddo
            enddo
          enddo
c.........Obtain the shift vector (with opposite direction)
          rcart2(1,nin)=x(nin)-x(nin+2)
          rcart2(2,nin)=y(nin)-y(nin+2)
          rcart2(3,nin)=z(nin)-z(nin+2)
          do i = 1, 3
            rcart(i) = rcart2(i,nin)
          enddo
c.........Transform the cartesians coordinates of shift vector to polar 
c         spherical coordinates and obtain shift multipole moments for
c         OUT(A) or OUT(B)
          call bol(rcart,rad,theta,phi)
          call rsh2(theta,phi,slm,il0,ltot) ! Obtain RSHs
          call calc_tnewmm(newmm2,oldmm1,rad,ltot)
c.....(D3): Recalculate the multipole moments in the initial position:
          rcart(1)=-rcart(1)
          rcart(2)=-rcart(2)
          rcart(3)=-rcart(3)
          call bol(rcart,rad,theta,phi)
          call rsh2(theta,phi,slm,il0,ltot) ! Obtain RSHs
          call calc_tnewmm(newmm1,newmm2,rad,ltot)
          !Note: newmm1 must be very similar to oldmm1
c.........Calculate relative deviation and reallocation of shift
c         multipole moments
          do l = 0, ltot
            do k = 0, l
              if (k.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                if (abs(oldmm1(l,k,i)).gt.TINY) then
                  devlki(l,k,i)=abs(newmm1(l,k,i)-oldmm1(l,k,i))
     &                          /abs(oldmm1(l,k,i))
                  if (devlki(l,k,i).gt.0.25d0) then
                    if (i.eq.1) then ! Qlmc
                      m = k
                    else ! Qlms
                      m = -k
                    endif
                    if (nin.eq.1) then ! atom A
                      write (stdout1,200) temp,l,m,oldmm1(l,k,i),
     &                                    devlki(l,k,i)
                    else ! atom B
                      write (stdout1,300) temp,l,m,oldmm1(l,k,i),
     &                                    devlki(l,k,i)
                    endif
                  endif
                else
                  devlki(l,k,i)=abs(newmm1(l,k,i)-oldmm1(l,k,i))
                  if (devlki(l,k,i).gt.EPSFRAC) then
                    if (i.eq.1) then ! Qlmc
                      m = k
                    else ! Qlms
                      m = -k
                    endif
                    if (nin.eq.1) then ! atom A
                      write (stdout1,400) temp,l,m,oldmm1(l,k,i),
     &                                    devlki(l,k,i)
                    else ! atom B
                      write (stdout1,500) temp,l,m,oldmm1(l,k,i),
     &                                    devlki(l,k,i)
                    endif
                  endif
                endif
                multim(nin+4,l,k,i)=newmm2(l,k,i)
              enddo
            enddo
          enddo
        enddo ! nin
c.....(D4): Calculate Coulomb interactions between atoms A and B
c           using ME:
        do is1 = 1, 2
          do is2 = 1, 2
c...........New allocation of nuclei coordinates
            isite1 = list1(is1)
            isite2 = list2(is2)
            coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
            coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c...........Calculation of polar coordinates using in ME tensor
            rab = coordB - coordA
            call bol(rab,rad,theta,phi)
            Rtmp(is1,is2) = rad
            thetmp(is1,is2) = theta
            phitmp(is1,is2) = phi
c...........New allocation of multipole moments
            isite3 = list3(is1)
            isite4 = list4(is2)
            do l = 0, ltot
              atomA(l+1,1,is1)=multim(isite3,l,0,1)
              atomB(l+1,1,is2)=multim(isite4,l,0,1)
              do k = 2, l+l+1
                atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
                atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
              enddo
            enddo
          enddo ! is2
        enddo ! is1
c.......ME
        do l = 0, ltot
          accume(j,l)=0d0
          do is1 = 1, 2
            do is2 = 1, 2
c.............Recover polar coordinates using in ME tensor
              R = Rtmp(is1,is2)
              theta = thetmp(is1,is2)
              phi = phitmp(is1,is2)
c.............Obtain RSHs using in ME tensor
              call rsh2(theta,phi,slm,il0,l+l) 
              do la= 0, l
                do lb= 0, l
                  do ka=-la,la
                    do kb=-lb,lb
c.....................Calculation of Qa*T*Qb
                      Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                      Qb=AtomB(lb+1,arrayk(kb),is2)
                      Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                      accume(j,l)=accume(j,l)+Qa*Tensor*Qb
                    enddo
                  enddo
                enddo
              enddo
            enddo ! is2
          enddo ! is1
        enddo ! l
c.....(D5): Obtain out betasphere multipoles in the origin using
c          shift multipole moments:
        x(3) = x(1)
        y(3) = y(1)
        z(3) = z(1)
        x(4) = x(2)
        y(4) = y(2)
        z(4) = z(2)
        do nin = 1, 2
c          nin = 1 <-> atomA : nin = 2 <-> atomB
          do l  = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                oldmm1(l,m,i) = multim(nin+4,l,m,i)
              enddo
            enddo
          enddo
c.........Obtain the shift vector (with opposite direction)
          do i = 1, 3
            rcart(i) = - rcart2(i,nin)
          enddo
c.........Transform the cartesians coordinates of shift vector to polar
c         spherical coordinates and obtain new multipole moments for
c         OUT(A) or OUT(B)
          call bol(rcart,rad,theta,phi)
          call rsh2(theta,phi,slm,il0,ltot) ! Obtain RSHs
          call calc_tnewmm(newmm2,oldmm1,rad,ltot)
c.........Reallocation of shift multipole moment
          do l = 0, ltot
            do m = 0, l
              if (m.eq.0) then
                imax = 1
              else
                imax = 2
              endif
              do i = 1, imax
                multim(nin+4,l,m,i) = newmm2(l,m,i)
              enddo
            enddo
          enddo
        enddo ! nin
c.....(D6): Calculate Coulomb interactions between atoms A and B
c           using ME:
        do is1 = 1, 2
          do is2 = 1, 2
c...........New allocation of nuclei coordinates
            isite1 = list1(is1)
            isite2 = list2(is2)
            coordA(1)=x(isite1);coordA(2)=y(isite1);coordA(3)=z(isite1)
            coordB(1)=x(isite2);coordB(2)=y(isite2);coordB(3)=z(isite2)
c...........Calculation of polar coordinates using in ME tensor
            rab = coordB - coordA
            call bol(rab,rad,theta,phi)
            Rtmp(is1,is2) = rad
            thetmp(is1,is2) = theta
            phitmp(is1,is2) = phi
c...........New allocation of multipole moments
            isite3 = list3(is1)
            isite4 = list4(is2)
            do l = 0, ltot
              atomA(l+1,1,is1)=multim(isite3,l,0,1)
              atomB(l+1,1,is2)=multim(isite4,l,0,1)
              do k = 2, l+l+1
                atomA(l+1,k,is1)=multim(isite3,l,int(k/2),mod(k,2)+1)
                atomB(l+1,k,is2)=multim(isite4,l,int(k/2),mod(k,2)+1)
              enddo
            enddo
          enddo ! is2
        enddo ! is1
c.......ME
        do l = 0, ltot
          accume2(j,l)=0d0
          do is1 = 1, 2
            do is2 = 1, 2
c.............Recover polar coordinates using in ME tensor
              R = Rtmp(is1,is2)
              theta = thetmp(is1,is2)
              phi = phitmp(is1,is2)
c.............Obtain RSHs using in ME tensor
              call rsh2(theta,phi,slm,il0,l+l)
              do la= 0, l
                do lb= 0, l
                  do ka=-la,la
                    do kb=-lb,lb
c.....................Calculation of Qa*T*Qb
                      Qa=AtomA(la+1,arrayk(ka),is1) !Note: array is a external function
                      Qb=AtomB(lb+1,arrayk(kb),is2)
                      Tensor=T2(la,ka,lb,kb) !Note: T2 is a external function
                      accume2(j,l)=accume2(j,l)+Qa*Tensor*Qb
                    enddo
                  enddo
                enddo
              enddo
            enddo ! is2
          enddo ! is1
        enddo ! l

c.....(D7): Calculate the truncation error and shift error:
        do l = 1, ltot
          etrunc(j,l) = accume(j,l) - accume(j,l-1)
          eredon(j,l) = accume2(j,l) - accex(l)
        enddo
      enddo ! ishift
      do j = 1, jmax
        do l = 1, ltot
          err(j,l) = abs(etrunc(j,l)) + abs(eredon(j,l))
        enddo
      enddo
c
c.....(E): Obtain the Err(l,rshift) minimums: 
c
      do l = 1, ltot
        i = 0
        rr1 = (err(2,l) - err(1,l))/(rshift(2) - rshift(1)) 
        do j = 2, jmax-1  
          rr2 = (err(j+1,l) - err(j,l))/(rshift(j+1) - rshift(j))
          if (rr1.lt.0d0 .and. rr2.gt.0d0) then
            i = i + 1
            vecmin(i,l) = j
          endif
          rr1 = rr2
        enddo 
        imx(l) = i
      enddo
      call cpu_time(tfin)
c
c.....(F): Order the minimums and print of results:
c
      write (stdout1,fmt=600) ltot, neq1, neq2
      do l = 1, ltot
        if (imx(l).gt.0) then
          do i = 1, imx(l)
            j = vecmin(i,l)
            ordm(i) = err(j,l)
          enddo
          call sortrx (imx(l),ordm,iord)
          do i = 1, imx(l)
            j = vecmin(iord(i),l)
            write (stdout1,fmt=800) l, rshift(j), accume(j,l),
     &                              ordm(iord(i))
          enddo
        endif
      enddo
      write (stdout1,fmt=700)
      do l = 1, ltot
        if (imx(l).gt.0) then 
          do i = 1, imx(l)
            j = vecmin(i,l)
            ordm(i) = err(j,l)
          enddo
          call sortrx (imx(l),ordm,iord)
          j = vecmin(iord(1),l)
          write (stdout1,fmt=800) l, rshift(j), accume(j,l),
     &                            ordm(iord(1))
        endif
      enddo     
      write (stdout1,900) tfin-tin
c
c.....(G): Deallocations:
c
      deallocate (il0, slm, multim, numbl, accex, imx, stat=ier)
      if (ier.ne.0)
     &  call error ('mod_mmmshift', 'Cannot deallocate il0 and/or slm
     & and/or multim and/or numbl and/or accex and/or imx', faterr)
      deallocate (accume, accume2, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mmmshift', 'Cannot deallocate accume and/
     &or accume2', faterr)
      deallocate (rshift, ordm, iord, vecmin, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mmmshift', 'Cannot deallocate rshift and/or
     & ordm and/or iord and/or vecmin', faterr) 
      deallocate (etrunc, eredon, err, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mmmshift', 'Cannot deallocate etrunc and/or
     & eredon and/or err', faterr)
      deallocate (oldmm1, newmm1, newmm2, devlki, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mmmshift', 'Cannot deallocate oldmm1 and/or
     & newmm1 and/or newmm2 and/or devlki', faterr)
      deallocate (atomA, atomB, stat=ier)
      if (ier.ne.0)
     & call error ('mod_mmmshift', 'Cannot deallocate atomA and/or
     & atomB', faterr)
c
c.....(I) end-of-comparative shift-run.
c

      write (stdout1,910)
      return
c
 100  format (/
     & 1x, '******************************************************'/
     & 1x, '**         - RHOLM: MINIMUM2 SHIT MODULE -          **'/
     & 1x, '**       (c) C.J.F Solano.  June 30, 2008           **'/
     & 1x, '******************************************************'// )
 200  format (1x,'ATOM A: SHIFT (bohr) = ',f12.5,1x,/,'L = ',i5,1x,
     &        1x,'M = ',i5,1x,'Qlm ='e15.8,1x,'RELATIVE ERROR =',e15.8)
 300  format (1x,'ATOM B: SHIFT (bohr) = ',f12.5,1x,/,'L = ',i5,1x,
     &        1x,'M = ',i5,1x,'Qlm ='e15.8,1x,'RELATIVE ERROR =',e15.8)
 400  format (1x,'ATOM A: SHIFT (bohr) = ',f12.5,1x,/,'L = ',i5,1x,
     &        1x,'M = ',i5,1x,'Qlm ='e15.8,1x,'ABSOLUTE ERROR =',e15.8)
 500  format (1x,'ATOM B: SHIFT (bohr) = ',f12.5,1x,/,'L = ',i5,1x,
     &        1x,'M = ',i5,1x,'Qlm ='e15.8,1x,'ABSOLUTE ERROR =',e15.8)
 600  format (1x,'*** 0 <= L <= ',i5,/,
     &        1x,'*** TOPOLOGICAL ATOMS',1x,i5,1x,'AND',1x,i5,/,
     &        1x,'*** MINIMUM2 SHIFT MODULE: SHIFT IN BOHRS AND
     & ENERGIES IN HARTREES',/,
     &        3x,'L',7x,'SHIFT',4x,'E(SHIFT,L)',13x,'Err(SHIFT,L)')
 700  format (/,1x,'*** MINIMUM2 SHIFT MODULE: THE BEST MINIMUM SHIFT',
     &        /,3x,'L',7x,'SHIFT',4x,'E(SHIFT,L)',13x,'Err(SHIFT,L)')
 800  format (1x,i3,1x,f12.5,1x,e23.15,1x,e23.15)
 900  format (1x,'*** TIME COMPUTATION ',f12.5,1x,'SECONDS')
 910  format (/1x, '*** END OF MINIMUM2 SHIT RUN *****************')
      end
