c---------------------------------------------------------------------------
      subroutine mod_pade(numb)
c---------------------------------------------------------------------------
      use datos, only : m, n, rank, cof, coft, ltotm, il0,
     & slm, resid, eq1, eq2, t1, t2, stdout1, faterr
      use libreria, only : error
      implicit real*8 (a-h,o-z)
      integer :: numb

c     "Pade" order (numb=1)
      if (numb.eq.1) then
       allocate (cof(rank), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate cof', faterr)
       ltotm = rank-1 
       allocate (il0(0:ltotm), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate il0', faterr)
       allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate slm', faterr)
       write (stdout1, fmt=100) eq1, eq2 
       call calc_coef ()
       resid=0.d0
       call cpu_time(t1)
       call calc_pade(cof,m,n,resid)
       call cpu_time(t2)
       call write_pade(numb)
       deallocate (cof, il0, slm, stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot deallocate cof and/or
     & il0 and/or slm', faterr)
c     "Autpade" order (numb=2)
      else if (numb.eq.2) then 
      allocate (cof(rank), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate cof', faterr)
      allocate (coft(rank), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate coft', faterr)
       ltotm = rank-1
       allocate (il0(0:ltotm), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate il0', faterr)
       allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot allocate slm', faterr)
       write (stdout1, fmt=200) eq1, eq2
       call calc_coef ()
       resid=0.d0
       do m=1,rank-2
        n=rank-(m+1)
        coft=cof
        call cpu_time(t1)
        call calc_pade(coft,m,n,resid)
        call cpu_time(t2)
        call write_pade(numb)
       enddo
       deallocate (cof, coft, il0, slm, stat=ier)
       if (ier.ne.0)
     &  call error ('mod_pade', 'Cannot deallocate cof and/or
     & coft and/or il0 and/or slm', faterr)
      endif
c
c-----Formats
c
 100  format ('PADE APROXIMANT:',/,'PUNTUAL
     & CALCULATION BETWEEN',1x,i5,1x,'AND',1x,i5,1x,'TOPOLOGICAL
     & ATOMS')
 200  format ('PADE APROXIMANT:',/,'ALL
     & CALCULATIONS BETWEEN',1x,i5,1x,'AND',1x,i5,1x,'TOPOLOGICAL
     & ATOMS',/,'DEGREE:',1x,'NUMERATOR',1x,'DENOMINATOR',1x,
     & 'Vee(ME) (a.u)',12x, 'Vee(ME) (kJ/mol)',9x,
     & 'NORM RESIDUAL VECTOR')
c
c-----End of the subroutine
c
      return
      end subroutine
