
c----------------------------------------------------------------------
c
      subroutine mod_shift () 
c---------------------------------------------------------------------
      use datos, only: stdin1,   stdout1, convergent,
     & line, word, mincrem, monoincrement, bincrem1, bincrem2,
     & bincrement, tincrem1, tincrem2, tincrem3, trincrement,
     & mmin, monomin, bmin, bimin, tmin, trimin, mmax, monomax,
     & bmax, bimax, tmax, trimax, llin1, llin2, rinc, alphin,
     & betin, pi, warning, convt, ltot, neq1, neq2
      use libreria, only: error, setword, leng, setdble, setint
      implicit real*8 (a-h,o-z)  
c.....LOCAL VARIABLES:   
      logical :: endshift 
      real*8 :: oldbinc1, oldbinc2, oldtinc1, oldtinc2, oldtinc3
      real*8 :: t1, t2
c
c.................................................................
c
      
C
C     ***************************************************************
C     *                                                             *
C     *    Read tasks to be done until an 'endshift' is found       *
C     *                                                             *
C     ***************************************************************
C
C
c
c-----Initializations
c
      monoincrement=.false.
      bincrement=.false.
      trincrement=.false.
      monomin=.false.
      monomax=.false.
      bimin=.false.
      bimax=.false.
      trimin=.false.
      trimax=.false.
      convergent=.false. 
      endshift=.false.      
 4    read (stdin1,500,end=5) line
      lp=1
      if (setword(word,line,lp)) then
        word=word(1:leng(word))
        if (word.eq.'endshift') then
         endshift=.true.
         goto 5
c
c-------Indicate convergent multipole expansion for the
c       interactions
c 
        else if (word.eq.'convergent') then
          if (.not.setdble (convt,line,lp)) then
           call error ('mod_shift', 'Convergent has not been
     & defined in "convergent" order', warning)
           goto 4
          endif
          if (convt.le.0d0) then
           call error ('mod_shift', 'convt is a negative or null
     & number', warning)
           goto 4
          endif
          convergent=.true.
          goto 4
c
c-------Calculate new shift multipole moments and 
c       Coulomb energy 
c
        else if (word.eq.'monoincrement') then
          if (.not.setdble (mincrem,line,lp)) then
           call error ('mod_shift', 'mincrem has not been
     & defined in "monoincrement" order', warning)
           goto 4
          endif
          if (mincrem.le.0d0) then
           call error ('mod_shift', 'mincrem is a negative or null
     & number', warning)
           goto 4
          endif   
          monoincrement=.true.
          goto 4           
        else if (word.eq.'bincrement') then
          if (.not.setdble (bincrem1,line,lp)) then
           call error ('mod_shift', 'bincrem1 and bincrem2 have not
     & been defined in "bincrement" order', warning)
           goto 4
          endif 
          if (bincrem1.le.0d0) then
           call error ('mod_shift', 'bincrem1 is a negative or null
     & number', warning)
           goto 4
          endif
          if (.not.setdble (bincrem2,line,lp)) then
           call error ('mod_shift', 'bincrem2 has not been
     & defined in "bincrement" order', warning)
           goto 4
          endif
          if (bincrem2.le.0d0) then
           call error ('mod_shift', 'bincrem2 is a negative or null
     & number', warning)
           goto 4
          endif  
          bincrement=.true.
          goto 4
        else if (word.eq.'trincrement') then
          if (.not.setdble (tincrem1,line,lp)) then
           call error ('mod_shift', 'tincrem1,tincrem2 and tincrem3
     & have not been defined in "trincrement" order', warning)
           goto 4
          endif
          if (tincrem1.le.0d0) then
           call error ('mod_shift', 'tincrem1 is a negative or null
     & number', warning)
           goto 4
          endif
          if (.not.setdble (tincrem2,line,lp)) then
           call error ('mod_shift', 'tincrem2 and tincrem3 have not
     & been defined in "trincrement" order', warning)
           goto 4
          endif  
          if (tincrem2.le.0d0) then
           call error ('mod_shift', 'tincrem2 is a negative or null
     & number', warning)
           goto 4
          endif
          if (.not.setdble (tincrem3,line,lp)) then
           call error ('mod_shift', 'tincrem3 has not been
     & defined in "trincrement" order', warning)
           goto 4
          endif 
          if (tincrem3.le.0d0) then
           call error ('mod_shift', 'tincrem3 is a negative or null
     & number', warning)
           goto 4
          endif
          trincrement=.true.
          goto 4 
        else if (word.eq.'monomin') then
          if (.not.setint (mmin,line,lp)) then
           call error ('mod_shift', 'mmin has not been
     & defined in "monomin" order', warning)
           goto 4
          endif
          if (mmin.lt.0) then
           call error ('mod_shift', 'mmin is a negative integer',
     & warning)
           goto 4
          endif
          monomin=.true.
          goto 4 
        else if (word.eq.'bimin') then
          if (.not.setint (bmin,line,lp)) then
           call error ('mod_shift', 'bmin has not been
     & defined in "bimin" order', warning)
           goto 4
          endif
          if (bmin.lt.0) then
           call error ('mod_shift', 'bmin is a negative integer',
     & warning)
           goto 4
          endif
          bimin=.true.
          goto 4
        else if (word.eq.'trimin') then
          if (.not.setint (tmin,line,lp)) then
           call error ('mod_shift', 'tmin has not been
     & defined in "trimin" order', warning)
           goto 4
          endif
          if (tmin.lt.0) then
           call error ('mod_shift', 'tmin is a negative integer', 
     & warning)
           goto 4
          endif
          trimin=.true.
          goto 4
        else if (word.eq.'monomax') then
          if (.not.setint (mmax,line,lp)) then
           call error ('mod_shift', 'mmax has not been
     & defined in "monomax" order', warning)
           goto 4
          endif
          if (mmax.lt.0) then
           call error ('mod_shift', 'mmax is a negative integer',
     & warning)
           goto 4
          endif
          monomax=.true.
          goto 4 
        else if (word.eq.'bimax') then
          if (.not.setint (bmax,line,lp)) then
           call error ('mod_shift', 'bmax has not been
     & defined in "bimax" order', warning)
           goto 4
          endif
          if (bmax.lt.0) then
           call error ('mod_shift', 'bmax is a negative integer',
     & warning)
           goto 4
          endif 
          bimax=.true.
          goto 4
        else if (word.eq.'trimax') then
          if (.not.setint (tmax,line,lp)) then
           call error ('mod_shift', 'tmax has not been
     & defined in "trimax" order', warning)
           goto 4
          endif
          if (tmax.lt.0) then
           call error ('mod_shift', 'tmax is a negative integer',
     & warning)
           goto 4
          endif
          trimax=.true.
          goto 4
        else if (word.eq.'monoshift') then
          if (.not.convergent) then
           call error ('mod_shift', 'Convergent has not been
     & defined before monoshift', warning)
           goto 4
          endif
          if (.not.monoincrement) then
           call error ('mod_shift', 'Increment has not been
     & defined before monoshift', warning)
           goto 4
          endif  
          if (.not.monomin) then
           call error ('mod_shift', 'Initial shift has not been
     & defined before monoshift', warning)
           goto 4
          endif
          if (.not.monomax) then
           call error ('mod_shift', 'Maximum shift has not been
     & defined before monoshift', warning)
           goto 4
          endif
          if (mmin.ge.mmax) then
           call error ('mod_shift', 'mmin is greather than or equal
     & to mmax', warning)
           goto 4
          endif
          write (stdout1,fmt=60)
          write (stdout1,fmt=900) ltot,neq1,neq2
          write (stdout1,fmt=100) mmin,mmax,mincrem
          write (stdout1,fmt=140) convt
          write (stdout1,fmt=540)
          call cpu_time(t1)
          call calcshift(0)
          call cpu_time(t2)
          write (stdout1,fmt=400) t2-t1
          goto 4
        else if (word.eq.'bishift') then
          if (.not.convergent) then
           call error ('mod_shift', 'Convergent has not been
     & defined before bishift', warning)
           goto 4
          endif
          if (.not.bincrement) then
           call error ('mod_shift', 'Increment has not been
     & defined before bishift', warning)
           goto 4
          endif 
          if (.not.bimin) then
           call error ('mod_shift', 'Initial shift has not been
     & defined before bishift', warning)
           goto 4
          endif
          if (.not.bimax) then
           call error ('mod_shift', 'Maximum shift has not been
     & defined before bishift', warning)
           goto 4
          endif
          if (bmin.ge.bmax) then
           call error ('mod_shift', 'bmin is greather than or equal
     & to bmax', warning)
           goto 4
          endif 
          write (stdout1,fmt=60)
          write (stdout1,fmt=900) ltot,neq1,neq2
          write (stdout1,fmt=200) bmin,bmax,bincrem1,bincrem2
          write (stdout1,fmt=140) convt
          write (stdout1,fmt=540)
          call cpu_time(t1)    
          call calcshift(1)
          call cpu_time(t2)
          write (stdout1,fmt=400) t2-t1
          goto 4
        else if (word.eq.'trishift') then
          if (.not.convergent) then
           call error ('mod_shift', 'Convergent has not been
     & defined before trishift', warning)
           goto 4
          endif
          if (.not.trincrement) then
           call error ('mod_shift', 'Increment has not been
     & defined before trishift', warning)
           goto 4
          endif 
          if (.not.trimin) then
           call error ('mod_shift', 'Initial shift has not been
     & defined before trishift', warning)
           goto 4
          endif
          if (.not.trimax) then
           call error ('mod_shift', 'Maximum shift has not been
     & defined before trishift', warning)
           goto 4
          endif
          if (tmin.ge.tmax) then
           call error ('mod_shift', 'tmin is greather than or equal
     & to tmax', warning)
           goto 4
          endif
          write (stdout1,fmt=60)
          write (stdout1,fmt=900) ltot,neq1,neq2
          write (stdout1,fmt=300) tmin,tmax,tincrem1,tincrem2,tincrem3
          write (stdout1,fmt=140) convt
          write (stdout1,fmt=540)
          call cpu_time(t1)  
          call calcshift(2)
          call cpu_time(t2)
          write (stdout1,fmt=400) t2-t1
          goto 4
        else if (word.eq.'allbishift') then
          if (.not.convergent) then
           call error ('mod_shift', 'Convergent has not been
     & defined before allbishift', warning)
           goto 4
          endif
          if (.not.bimin) then
           call error ('mod_shift', 'Initial shift has not been
     & defined before allbishift', warning)
           goto 4
          endif
          if (.not.bimax) then
           call error ('mod_shift', 'Maximum shift has not been
     & defined before allbishift', warning)
           goto 4
          endif  
          if (bmin.ge.bmax) then
           call error ('mod_shift', 'bmin is greather than or equal
     & to bmax', warning)
           goto 4
          endif
          if (.not.setint(llin1,line,lp)) then
           call error ('mod_shift', 'llin1 has not been defined
     & in "allbishift" order', warning)
            goto 4
          endif
          if (.not.setdble(rinc,line,lp)) then
           call error ('mod_shift', 'rinc has not been defined
     & in "allbishift" order', warning)
           goto 4
          endif
          if (llin1.le.0.and.rinc.le.0) then
           call error ('mod_shift', 'llin1 and rinc can not be zero
     & or negative numbers', warning)
           goto 4
          endif 
          if (llin1.le.0) then
           call error ('mod_shift', 'llin1 can not be zero or a
     & negative number', warning)
           goto 4
          endif
          if (rinc.le.0) then
           call error ('mod_shift', 'rinc can not be zero or a
     & negative number', warning)
           goto 4
          endif
          if (bincrement) then
           oldbinc1=bincrem1
           oldbinc2=bincrem2  
          endif
          bincrem1=0d0;bincrem2=0d0 ! Initializations
          alphin=pi/llin1
          write (stdout1,fmt=60)
          write (stdout1,fmt=900) ltot,neq1,neq2
          write (stdout1,fmt=600) llin1,alphin,rinc
          write (stdout1,fmt=140) convt
          write (stdout1,fmt=800) bmin,bmax
          call cpu_time(t1)
          call allshift (0)
          call cpu_time(t2)
          write (stdout1,fmt=400) t2-t1
          if (bincrement) then
           bincrem1=oldbinc1
           bincrem2=oldbinc2  
          endif  
          goto 4
        else if (word.eq.'alltrishift') then
          if (.not.convergent) then
           call error ('mod_shift', 'Convergent has not been
     & defined before alltrishift', warning)
           goto 4
          endif 
          if (.not.trimin) then
           call error ('mod_shift', 'Initial shift has not been
     & defined before alltrishift', warning)
           goto 4
          endif
          if (.not.trimax) then
           call error ('mod_shift', 'Maximum shift has not been
     & defined before alltrishift', warning)
           goto 4
          endif
          if (tmin.ge.tmax) then
           call error ('mod_shift', 'tmin is greather than or equal
     & to tmax', warning)
           goto 4
          endif
          if (.not.setint(llin1,line,lp)) then
           call error ('mod_shift', 'llin1 has not been defined
     & in "alltrishift" order', warning)
           goto 4
          endif
          if (.not.setint(llin2,line,lp)) then
           call error ('mod_shift', 'llin2 has not been defined
     & in "alltrishift" order', warning)
           goto 4
          endif
          if (.not.setdble(rinc,line,lp)) then
           call error ('mod_shift', 'rinc has not been defined
     & in "alltrishift" order', warning)
           goto 4
          endif
          if (llin1.le.0.and.llin2.le.0.and.rinc.le.0) then
           call error ('mod_shift', 'llin1, llin2 and rinc can not be
     & zero or negative numbers', warning)
           goto 4
          endif
          if (llin1.le.0.and.llin2.le.0) then
           call error ('mod_shift', 'llin1 and llin2 can not be
     & zero or negative numbers', warning)
           goto 4
          endif
          if (llin2.le.0.and.rinc.le.0) then 
           call error ('mod_shift', 'llin2 and rinc can not be
     & zero or negative numbers', warning)
           goto 4
          endif
          if (llin1.le.0.and.rinc.le.0) then
           call error ('mod_shift', 'llin1 and rinc can not be
     & zero or negative numbers', warning)
           goto 4
          endif
          if (llin1.le.0) then
           call error ('mod_shift', 'llin1 can not be zero or a
     & negative number',warning)
           goto 4
          endif
          if (llin2.le.0) then
           call error ('mod_shift', 'llin2 can not be zero or a
     & negative number',warning)
           goto 4
          endif
          if (rinc.le.0) then
           call error ('mod_shift', 'rinc can not be zero or a
     & negative number',warning) 
           goto 4
          endif
          if (trincrement) then
           oldtinc1=tincrem1
           oldtinc2=tincrem2
           oldtinc3=tincrem3
          endif
          tincrem1=0d0;tincrem2=0d0;tincrem3=0d0 ! Initializations
          betin=pi/llin1
          alphin=pi/llin2
          write (stdout1,fmt=60)
          write (stdout1,fmt=900) ltot,neq1,neq2
          write (stdout1,fmt=700) llin1,llin2,betin,alphin,rinc
          write (stdout1,fmt=140) convt
          write (stdout1,fmt=800) tmin,tmax
          call cpu_time(t1)
          call allshift (1)
          call cpu_time(t2)
          write (stdout1,fmt=400) t2-t1
          if (trincrement) then
           tincrem1=oldtinc1
           tincrem2=oldtinc2
           tincrem3=oldtinc3  
          endif   
          goto 4  
        else
          goto 4
        endif
      else
        goto 4
      endif     
c
 5    if (.not.endshift) then
       call error ('mod_shift', 'Cannot find "endshift" order',
     & warning)
       return
      endif
 
c 
c-----Formats
c
 500  format (a)
 140  format (1x,'# CONVERGENCE CRITERIA (u.a)=',1x,e23.16)
 100  format (1x,'# ONE-DIMESIONAL SHIFT',/,1x,'# INITIAL VALUE=',1x,i5,
     & 1x,'FINAL VALUE=',1x,i5,1x,'INCREMENT=',1x,f10.6)
 200  format (1x,'# TWO-DIMESIONAL SHIFT',/,1x,'# INITIAL VALUE=',1x,i5,
     & 1x,'FINAL VALUE=',1x,i5,1x,'INCREMENT=',1x,'(',1x,f10.6,',',1x,
     & f10.6,1x,')')
 300  format (1x,'# THREE-DIMESIONAL SHIFT',/,1x,'# INITIAL VALUE=',1x,
     & i5,1x,'FINAL VALUE=',1x,i5,1x,'INCREMENT=',1x,'(',1x,f10.6,',',
     & 1x,f10.6,1x,',',1x,f10.6,1x,')')
 400  format (1x,'# TIME COMPUTATION=',1x,e23.6,1x,'SECONDS')
 540  format (1x,'# ITERATION',2x,'RANK: BETA(1-2)',1x,'OUT(1-2)',1x,
     &'BETA-OUT(1-2)',1x,'BETA-OUT(2-1)',1x,'ENERGY(u.a)',13x,
     &'ENERGY(kJ/mol)')
 600  format (1x,'# TWO-DIMENSIONAL SHIFT EXPLORATION',/,
     &1x,'# ANGLE DENOMINATOR=',1x,i5,/,1x,'# STANDARD ALPHA ANGLE=',1x
     &f10.6,1x,'RADIANS',/,1x,'# INCREMENT=',1x,f10.6)
 700  format (1x,'# THREE-DIMENSIONAL SHIFT EXPLORATION',/,
     &1x,'# ANGLE DENOMINATORS=',1x,'(',1x,i5,1x,i5,')',/,
     &1x,'# STANDARD BETA AND ALPHA ANGLES',1x,'(',1x,f10.6,1x,f10.6,')'
     &,1x,'RADIANS',/,1x,'# INCREMENT=',1x,f10.6)
 800  format (1x,'# INITIAL VALUE=',1x,i5,1x,'FINAL VALUE=',1x,i5)
 60   format ('_______________________________________________________
     &____________________')
 900  format (1x,'# LTOT=',1x,i5,/,1x,'# TOPOLOGICAL ATOMS',1x,i5,
     & 1x,'AND',1x,i5)
c
c-----End subroutine
c
      return 
      end subroutine
