c
c-----------------------------------------------------------------------------------------
c
      subroutine readmat (typ,ok)
c
c-----------------------------------------------------------------------------------------
c
      use datos, only: stdin1, line, word, rotop, neq1, warning, neq,
     & scr, scrb 
      use libreria, only : setword, leng, setdble, error
      implicit real*8 (a-h,o-z)
      logical :: typ, ok
c-----LOCAL VARIABLES
      integer :: lp, i, j, k
      logical :: ok1, ok2, ok3, logend
      real*8 :: num, num1
      real*8, parameter :: TINY = 1d-14

c
c-----Read elements of the rotation matrices
c
      ok=.false.
      ok1=.false.
      ok2=.false.
      ok3=.false.
      logend=.false.
 1    read (stdin1, 500, end=2) line
      lp=1
      if (setword(word,line,lp)) then
       word=word(1:leng(word))
       if (word.eq.'file1') then
        if (.not.setdble(rotop(1,1,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif     
        if (.not.setdble(rotop(1,2,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        if (.not.setdble(rotop(1,3,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        ok1=.true. 
        goto 1
       else if (word.eq.'file2') then
        if (.not.setdble(rotop(2,1,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        if (.not.setdble(rotop(2,2,neq1),line,lp)) then
          call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        if (.not.setdble(rotop(2,3,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        ok2=.true. 
        goto 1
       else if (word.eq.'file3') then
        if (.not.setdble(rotop(3,1,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been
     & defined', warning)
         return
        endif
        if (.not.setdble(rotop(3,2,neq1),line,lp)) then
         call error ('readmat', 'Rotation matrix has not been         
     & defined', warning) 
         return 
        endif                                         
        if (.not.setdble(rotop(3,3,neq1),line,lp)) then 
         call error ('readmat', 'Rotation matrix has not been    
     & defined', warning)
         return
        endif  
        ok3=.true.
        goto 1
       else if (word.eq.'endineq' .or. word.eq.'endall') then
        if (.not.typ) then ! 'ineq' keyword   
         logend=word.eq.'endineq'
         if (logend) goto 2
         goto 1 
        else ! 'all' keyword
         logend=word.eq.'endall'
         if (logend) goto 2
         goto 1
        endif
       else
        goto 1
       endif   
      else
       goto 1
      endif 
c
 2     if (.not.logend) then
        if (.not.typ) then ! 'ineq' keyword
         call error ('readmat', 'Cannot find "endineq" order', warning)
        else ! 'all' keyword
         call error ('readmat', 'Cannot find "endall" order', warning)
        endif
        return
       endif
       if (.not.ok1) then
        call error ('readmat', 'file 1 has not been defined in rotation
     & matrix', warning)
        return
       endif
       if (.not.ok2) then
        call error ('readmat', 'file 2 has not been defined in rotation
     & matrix', warning)
        return
       endif   
       if (.not.ok3) then
        call error ('readmat', 'file 3 has not been defined in rotation
     & matrix', warning)
        return
       endif
c
c-----Test if the rotation matrices are orthogonal
c
       i = 0 
       do while (i.le.3)
         i = i + 1
c--------diagonal elements for rotop * t^rotop         
         num = 0d0
         do j = 1, 3
           num = num + rotop(i,j,neq1)*rotop(i,j,neq1)
         enddo   
         if (abs(num-1d0).gt.TINY) then
          call error ('readmat', 'Rotation matrix is not orthogonal',
     & warning)
          return
         endif 
c--------non diagonal elements for rotop * t^rotop
         do i2 = 1, 3
           if (i2.ne.i) then
             num = 0d0
             do j = 1, 3
               num = num + rotop(i,j,neq1)*rotop(i2,j,neq1)
             enddo
             if (abs(abs(num)-0d0).gt.TINY) then 
              call error ('readmat', 'Rotation matrix is not
     & orthogonal', warning)
              return
             endif
           endif 
         enddo
       enddo
c
c-----Rotation matrices
c
       if (.not.typ) then ! 'ineq' keyword
        call rotmat (.false.)
        if (scr) then
         call rotall (.true.,.false.)
        endif
        if (scrb) then
         call rotall (.false.,.false.)
        endif
       else ! 'all' keyword
        call rotmat (.true.)
        if (scr) then
         call rotall (.true.,.true.)
        endif
        if (scrb) then
         call rotall (.false.,.true.)
        endif
       endif
c
       ok=.true. !end of run ok
c
c-----Formats
c
 500  format (a)

c
c-----End subroutine
c
      end subroutine
