c------------------------------------------------------------------------------------------------
      subroutine readvec (typ,ok)
c------------------------------------------------------------------------------------------------
      use datos, only : neq1, neq, rotop, scr, scrb, warning
      use libreria, only : error 
      implicit real*8 (a-h,o-z)
      logical :: typ, ok
c-----LOCAL VARIABLES
      logical :: logrot
      integer :: i, j, k
      real*8 :: num 
      real*8, parameter :: TINY = 1d-14

      ok=.false.
      logrot=.false.
c
c-----Normalization rotop(3,1,neq1)^2 + rotop(3,2,neq1)^2 +
c     rotop(3,3,neq1)^2 = 1
c
      num=0d0
      do i = 1, 3
       num = num + rotop(3,i,neq1)*rotop(3,i,neq1)
      enddo
      num = sqrt(num)
      do i = 1, 3
       rotop(3,i,neq1) = rotop(3,i,neq1)/num ! Normalization
      enddo
      if (abs(abs(rotop(3,3,neq1))-1d0).lt.TINY) then
       if (rotop(3,3,neq1).gt.0d0) then
        call error ('readvec', 'vector agrees with z-axis', warning)
        return
       else
        logrot=.true.
       endif
      endif 
      call calcrot (logrot)
      if (.not.typ) then ! 'ineq' heyword
       call rotmat (.false.)
       if (scr) then
        call rotall (.true.,.false.)
       endif
       if (scrb) then
        call rotall (.false.,.false.)
       endif    
      else ! 'all' keyword
       do i = 2, neq
        do j = 1, 3
         do k = 1, 3
          rotop(k,j,i) = rotop(k,j,neq1)
         enddo
        enddo
       enddo
       call rotmat (.true.) 
       if (scr) then
        call rotall (.true.,.true.)
       endif
       if (scrb) then
        call rotall (.false.,.true.)
       endif  
      endif
c
      ok=.true. ! end of run ok
c
c-----End subroutine
c
      return
      end subroutine
