      subroutine rotall (logi,typ)
c
c.....rotall - use rotor matrices to rotate Rlm up to angular momentum lmax
c
       use datos, only : neq, neq1, nr, nrb, lmax, llmax, lmax2, llmax2,
     &  rotr, rholm, brholm, lognotel
      implicit real*8 (a-h,o-z)
c     logi............. is .true. outside betasphere and .false. in
c                       otherwise
      logical :: logi, typ
c-----LOCAL VARIABLES
      real*8, dimension (:,:,:) :: rholm2(0:nr-1,1:neq,0:lmax2),
     &  brholm2(0:nrb-1,1:neq,0:llmax2)
      integer :: ic, n, il1, lm2, irt12, l, m2, m1, lm
c 
      if (.not.typ) then ! 'ineq' keyword
       if (logi) then ! outside betasphere
        do n = 0, nr-1 ! loop over radial points
c        il1 will point to the elements (l=0,1,2,...;m=0) or
c        lm=0,2,6,... for rholm
         il1 = 0  
c        lm2 will point to the elements (l,m) or lm for rholm2
         lm2 = 0
c        irt12 will point to the elements of R^l matrix
         irt12 = 1
         do l = 1, lmax ! loop over angular quantum number
          il1 = il1 + l + l ! il1=l*(l+1)
          do m2 = -l, l ! loop over azimutal quantum number
           lm2 = lm2 + 1 ! lm2=l*(l+1)+m2
           rholm2(n,neq1,lm2) = 0d0 ! Initializations
c          Rrho2_{lm2} = \hat{R} Rrho_{lm2} (\vec{r}) 
c                      = Rrho_{lm2} (\hat{R}^{-1} \vec{r})
c                      = \sum_{m1} Rrho_{lm1} R_{m1,m2}^l
           do m1 = -l, l
            irt12 = irt12 + 1 
            rholm2(n,neq1,lm2) = rholm2(n,neq1,lm2) + 
     &      rholm(n,neq1,il1+m1)*rotr(irt12,neq1)
           enddo
          enddo
         enddo
        enddo
        do n = 0, nr-1
         do l = 1, lmax
          do m = -l, l
           lm = l*(l+1) + m
           rholm(n,neq1,lm) = rholm2(n,neq1,lm) ! Copy rholm2 in rholm
          enddo
         enddo
        enddo
       else !inside betasphere
        do n = 0, nrb-1 ! loop over radial points
c        il1 will point to the elements (l=0,1,2,...;m=0) or
c        lm=0,2,6,... for brholm
         il1 = 0
c        lm2 will point to the elements (l,m) or lm for brholm2
         lm2 = 0
c        irt12 will point to the elements of R^l matrix
         irt12 = 1
         do l = 1, llmax ! loop over angular quantum number
          il1 = il1 + l + l ! il1=l*(l+1)
          do m2 = -l, l ! loop over azimutal quantum number
           lm2 = lm2 + 1 ! lm2=l*(l+1)+m2
           brholm2(n,neq1,lm2) = 0d0 ! Initializations
c          bRrho2_{lm2} = \hat{R} bRrho_{lm2} (\vec{r}) 
c                       = bRrho_{lm2} (\hat{R}^{-1} \vec{r})
c                       = \sum_{m1} bRrho_{lm1} R_{m1,m2}^l
           do m1 = -l, l
            irt12 = irt12 + 1
            brholm2(n,neq1,lm2) = brholm2(n,neq1,lm2) +
     &      brholm(n,neq1,il1+m1)*rotr(irt12,neq1)
           enddo
          enddo
         enddo
        enddo
        do n = 0, nrb-1
         do l = 1, llmax
          do m = -l, l
           lm = l*(l+1) + m
           brholm(n,neq1,lm) = brholm2(n,neq1,lm) ! Copy brholm2 in brholm
          enddo 
         enddo
        enddo
       endif
      else ! 'all' keyword
       if (logi) then ! outside betasphere
        do ic = 1, neq ! loop over no equivalent atoms
         do n = 0, nr-1 ! loop over radial points
c         il1 will point to the elements (l=0,1,2,...;m=0) or
c         lm=0,2,6,... for rholm
          il1 = 0
c         lm2 will point to the elements (l,m) or lm for rholm2
          lm2 = 0
c         irt12 will point to the elements of R^l matrix
          irt12 = 1
          do l = 1, lmax ! loop over angular quantum number
           il1 = il1 + l + l ! il1=l*(l+1)
           do m2 = -l, l ! loop over azimutal quantum number
            lm2 = lm2 + 1 ! lm2=l*(l+1)+m2
            rholm2(n,ic,lm2) = 0d0 ! Initializations
c           Rrho2_{lm2} = \hat{R} Rrho_{lm2} (\vec{r}) 
c                       = Rrho_{lm2} (\hat{R}^{-1} \vec{r})
c                       = \sum_{m1} Rrho_{lm1} R_{m1,m2}^l
            do m1 = -l, l
             irt12 = irt12 + 1 
             rholm2(n,ic,lm2) = rholm2(n,ic,lm2) + 
     &       rholm(n,ic,il1+m1)*rotr(irt12,ic)
            enddo
           enddo
          enddo
         enddo
        enddo
        do ic = 1,neq
         do n = 0, nr-1
          do l = 1, lmax
           do m = -l, l
            lm = l*(l+1) + m
            rholm(n,ic,lm) = rholm2(n,ic,lm) ! Copy rholm2 in rholm
           enddo
          enddo
         enddo
        enddo 
       else !inside betasphere
        do ic = 1, neq ! loop over no equivalent atoms 
         do n = 0, nrb-1 ! loop over radial points
c         il1 will point to the elements (l=0,1,2,...;m=0) or
c         lm=0,2,6,... for brholm
          il1 = 0
c         lm2 will point to the elements (l,m) or lm for brholm2
          lm2 = 0
c         irt12 will point to the elements of R^l matrix
          irt12 = 1
          do l = 1, llmax ! loop over angular quantum number
           il1 = il1 + l + l ! il1=l*(l+1)
           do m2 = -l, l ! loop over azimutal quantum number
            lm2 = lm2 + 1 ! lm2=l*(l+1)+m2
            brholm2(n,ic,lm2) = 0d0 ! Initializations
c           bRrho2_{lm2} = \hat{R} bRrho_{lm2} (\vec{r}) 
c                        = bRrho_{lm2} (\hat{R}^{-1} \vec{r})
c                        = \sum_{m1} bRrho_{lm1} R_{m1,m2}^l
            do m1 = -l, l
             irt12 = irt12 + 1
             brholm2(n,ic,lm2) = brholm2(n,ic,lm2) +
     &       brholm(n,ic,il1+m1)*rotr(irt12,ic)
            enddo
           enddo
          enddo
         enddo
        enddo
        do ic = 1, neq
         do n = 0, nrb-1
          do l = 1, llmax
           do m = -l, l
            lm = l*(l+1) + m
            brholm(n,ic,lm) = brholm2(n,ic,lm) ! Copy brholm2 in brholm
           enddo
          enddo
         enddo
        enddo
       endif 
      endif     
c
      lognotel=.true. ! This logical variable indicates that 
                      ! rotations have been executed in Rlm(r) 
c
c.....routine ends
c
      return
      end subroutine

