c---------------------------------------------------------------------
      subroutine rotdip (index)
c---------------------------------------------------------------------
      use datos, only : stdin1, line, word, warning, neq, 
     & neq1, eq1, rotop, bqlm, qlm, qtot, brhoqlm, rhoqlm, qlmtot,
     & Q22, W, logliber
      use libreria, only : setword, leng, setint, error, equiv
      implicit real*8 (a-h,o-z)
      integer :: index
c-----LOCAL VARIABLES
      integer :: rot2, lp, i, j
      real*8 :: num
      logical :: endrot, ok, logrot
      real*8, parameter :: TINY = 1d-14
c
      endrot=.false.
 1    read (stdin1,500,end=2) line
      lp=1
      if (setword(word,line,lp)) then
       word=word(1:leng(word))
       if (word.eq.'endrotdip') then
        endrot=.true.
        goto 2
       else if (word.eq.'ineq') then
        if (.not.setint(eq1,line,lp)) then
         call error ('rotdip', 'Cannot find an atom',
     & warning)
         goto 1
        endif
c
c------If neq1 is a no equivalent atom, then ok=.true.
c
        ok = equiv(eq1,neq1)
        if (.not.ok) then
         call error ('rotdip', 'neq1 is not a inequivalent atom',
     & warning)
         goto 1
        endif
c
        rot2 = 3
        logrot = .false.
c
c-------The dipolar moment is (-Q  ,-Q  ,Q  ), where Q  =brhoqlm, rhoqlm 
c                                11   1-1 10          lm
c       or qlmtot  
        if (index.eq.1) then ! 'inside' keyword
         if (bqlm) then
          rotop(3,1,neq1)=-brhoqlm(neq1,3)
          rotop(3,2,neq1)=-brhoqlm(neq1,1) 
          rotop(3,3,neq1)=brhoqlm(neq1,2)
         else
          call error ('rotdip', 'brhoqlm has not been defined before
     & "rotdip inside" order', warning)
          goto 1
         endif
        else if (index.eq.2) then ! 'outside' keyword
         if (qlm) then
          rotop(3,1,neq1)=-rhoqlm(neq1,3)
          rotop(3,2,neq1)=-rhoqlm(neq1,1)
          rotop(3,3,neq1)=rhoqlm(neq1,2)
         else
          call error ('rotdip', 'rhoqlm has not been defined before
     & "rotdip outside" order', warning)
          goto 1
         endif
        else ! 'total' keyword
         if (qtot) then
          rotop(3,1,neq1)=-qlmtot(neq1,3)
          rotop(3,2,neq1)=-qlmtot(neq1,1)
          rotop(3,3,neq1)=qlmtot(neq1,2)
         else
          call error ('rotdip', 'qlmtot has not been defined before
     & "rotdip total" order', warning)
          goto 1
         endif
        endif
c
c-------Normalization
c       rotop(3,1,neq1)^2+rotop(3,2,neq1)^2+rotop(3,3,neq1)^2=1
c
        num=0d0
        do i = 1, 3
         num = num + rotop(3,i,neq1)*rotop(3,i,neq1)
        enddo
        num = sqrt(num)
        if (num.eq.0d0) then
         write (*,*) 'ATOM: ',eq1
         call error ('rotdip', 'ineq. atom is a non nuclear
     & maximum', warning)
         return
        endif
        do i = 1, 3
         rotop(3,i,neq1) = rotop(3,i,neq1)/num ! Normalization
        enddo
c
c-------Obtain rotation matrix for neq1 atom
c
        if (.not.logliber) then ! 2 degree freedom
         if (abs(abs(rotop(3,3,neq1))-1d0).lt.TINY) then
          if (rotop(3,3,neq1).gt.0d0) then
           write (*,*) 'ATOM: ',eq1
           call error ('rotdip', 'vector agrees with z-axis', warning)
           return
          else
           logrot=.true.
          endif
         endif
         call calcrot(logrot)  
        else ! 1 degree freedom
         if (index.eq.1) then ! 'inside' keyword
          Q22 = brhoqlm(neq1,8)
          W = brhoqlm(neq1,4) + sqrt(brhoqlm(neq1,8)*brhoqlm(neq1,8) + 
     &                               brhoqlm(neq1,4)*brhoqlm(neq1,4))
         else if (index.eq.2) then ! 'outside' keyword
          Q22 = rhoqlm(neq1,8)
          W = rhoqlm(neq1,4) + sqrt(rhoqlm(neq1,8)*rhoqlm(neq1,8) +
     &                               rhoqlm(neq1,4)*rhoqlm(neq1,4)) 
         else ! 'total' keyword
          Q22 = qlmtot(neq1,8)
          W = qlmtot(neq1,4) + sqrt(qlmtot(neq1,8)*qlmtot(neq1,8) +
     &                               qlmtot(neq1,4)*qlmtot(neq1,4))
         endif
         if (abs(abs(rotop(3,3,neq1))-1d0).lt.TINY) then
          if (rotop(3,3,neq1).gt.0d0) then
           rot2=1
          else
           rot2=2
          endif
         endif    
         call calcrot2(rot2)
        endif
c        
c-------Compute rotation matrices for RSHs and rotate Rlm's
c
        call rotmat (.false.)            
        if (index.eq.1) then ! 'inside' keyword
         call rotall (.false.,.false.)
         call write_rotdip (.false.,1) 
        else if (index.eq.2) then ! 'outside' keyword
         call rotall (.true.,.false.)
         call write_rotdip (.false.,2)
        else ! index=3 'total' keyword
         call rotall (.false.,.false.)
         call rotall (.true.,.false.)
         call write_rotdip (.false.,3)
        endif 
        goto 1
       else if (word.eq.'all') then
        do i = 1, neq
         neq1 = i
         rot2 = 3
         logrot = .false.
c
c--------The dipolar moment is (-Q  ,-Q  ,Q  ), where Q  =brhoqlm, rhoqlm 
c                                11   1-1 10          lm
c        or qlmtot  
         if (index.eq.1) then ! 'inside' keyword
          if (bqlm) then
           rotop(3,1,neq1)=-brhoqlm(neq1,3)
           rotop(3,2,neq1)=-brhoqlm(neq1,1)
           rotop(3,3,neq1)=brhoqlm(neq1,2)
          else
           call error ('rotdip', 'brhoqlm has not been defined before
     & "rotdip inside" order', warning)
           goto 1
          endif
         else if (index.eq.2) then ! 'outside' keyword
          if (qlm) then
           rotop(3,1,neq1)=-rhoqlm(neq1,3)
           rotop(3,2,neq1)=-rhoqlm(neq1,1)
           rotop(3,3,neq1)=rhoqlm(neq1,2)
          else 
           call error ('rotdip', 'rhoqlm has not been defined before
     & "rotdip outside" order', warning)
           goto 1
          endif
         else ! 'total' keyword
          if (qtot) then
           rotop(3,1,neq1)=-qlmtot(neq1,3)
           rotop(3,2,neq1)=-qlmtot(neq1,1)
           rotop(3,3,neq1)=qlmtot(neq1,2)
          else
           call error ('rotdip', 'qlmtot has not been defined before
     & "rotdip total" order', warning)
           goto 1
          endif
         endif
c
c--------Normalization
c        rotop(3,1,neq1)^2+rotop(3,2,neq1)^2+rotop(3,3,neq1)^2=1
c
         num=0d0
         do j = 1, 3
          num = num + rotop(3,j,neq1)*rotop(3,j,neq1)
         enddo
         num = sqrt(num)
         if (num.eq.0d0) then
           write (*,*) 'ATOM: ',eq1
           call error ('rotdip', 'ineq. atom is a non nuclear
     & maximum', warning)
           goto 3
         endif
         do j = 1, 3
          rotop(3,j,neq1) = rotop(3,j,neq1)/num ! Normalization
         enddo
c
c--------Obtain rotation matrix for neq1 atom
c
         if (.not.logliber) then ! 2 degree freedom
          if (abs(abs(rotop(3,3,neq1))-1d0).lt.TINY) then
           if (rotop(3,3,neq1).gt.0d0) then
            write (*,*) 'ATOM: ',eq1
            call error ('rotdip', 'vector agrees with z-axis', warning)
            goto 3
           else
            logrot=.true.
           endif
          endif
          call calcrot(logrot)
         else ! 1 degree freedom
          if (index.eq.1) then ! 'inside' keyword
           Q22 = brhoqlm(neq1,8)
           W = brhoqlm(neq1,4) + sqrt(brhoqlm(neq1,8)*brhoqlm(neq1,8) +
     &                                brhoqlm(neq1,4)*brhoqlm(neq1,4))
          else if (index.eq.2) then ! 'outside' keyword
           Q22 = rhoqlm(neq1,8)
           W = rhoqlm(neq1,4) + sqrt(rhoqlm(neq1,8)*rhoqlm(neq1,8) +
     &                                rhoqlm(neq1,4)*rhoqlm(neq1,4))
          else ! 'total' keyword
           Q22 = qlmtot(neq1,8)
           W = qlmtot(neq1,4) + sqrt(qlmtot(neq1,8)*qlmtot(neq1,8) +
     &                                qlmtot(neq1,4)*qlmtot(neq1,4))
          endif
          if (abs(abs(rotop(3,3,neq1))-1d0).lt.TINY) then
           if (rotop(3,3,neq1).gt.0d0) then
            rot2=1
           else
            rot2=2
           endif
          endif
          call calcrot2(rot2)
         endif
c
c--------Compute rotation matrices for RSHs and rotate Rlm's
c
         call rotmat (.false.)           
         if (index.eq.1) then ! 'inside' keyword
          call rotall (.false.,.false.)
          call write_rotdip (.true.,1)
         else if (index.eq.2) then ! 'outside' keyword
          call rotall (.true.,.false.)
          call write_rotdip (.true.,2)
         else ! 'total' keyword
          call rotall (.false.,.false.)
          call rotall (.true.,.false.)
          call write_rotdip (.true.,3)
         endif
 3       continue
        enddo
        goto 1
       else
        goto 1
       endif
      else
       goto 1
      endif 
 2    if (.not.endrot) then
       call error ('rotdip', 'Cannot find "endrotdip" order',
     & warning)
       return
      endif
c
c-----Formats
c
 500  format (a)
c
c-----End subroutine
c
      return
      end subroutine       
