      subroutine rotmat (typ)
c
c.....rotmat - compute the rotation matrices for RSHs up to order lpmax
c
       use datos, only : irot0, rotr, rotop, neq, neq1, lpmax
       use libreria, only : rotrecur
       implicit real*8 (a-h,o-z)
c      lpmax ............ maximum angular momentum to compute rotr

       logical :: typ
c
c.....LOCAL VARIABLES:
      integer :: ic, i, i1, i2, l, m1, m2

      if (.not.typ) then ! 'ineq' keyword
c
c.....rotation matrices for l=0 and l=1; mod(m+2,3)+1 transforms
c     m=(-1,0,1) into i=(2,3,1), i.e., (y,z,x)
c

c     irot0()........ pointer to first element of R^l in rotr (), which
c                     is 1+l*(2l-1)*(2l+1)/3
       irot0(0) = 1
       rotr(1,neq1) = 1d0 !R_{0,0}^0=1
       i = 2
       irot0(1) = 2
       do m2 = -1, 1
        i2 = mod(m2+2,3) + 1
        do m1 = -1, 1
         i1 = mod(m1+2,3) + 1
c        R_{-1,-1}^1=rotop(2,2,neq1)(i=2);R_{0,-1}^1=rotop(3,2,neq1)(i=3)
c        R_{1,-1}^1=rotop(1,2,neq1)(i=4);R_{-1,0}^1=rotop(2,3,neq1)(i=5) 
c        R_{0,0}^1=rotop(3,3,neq1)(i=6);R_{1,0}^1=rotop(1,3,neq1)(i=7)
c        R_{-1,1}^1=rotop(2,1,neq1)(i=8);R_{0,1}^1=rotop(3,1,neq1)(i=9)
c        R_{1,1}^l=rotop(1,1,neq1)(i=10)
         rotr(i,neq1) = rotop(i1,i2,neq1)
         i = i + 1
        enddo
       enddo
c
c.....loop over l values, obtaining each R^l by recurrence from R^(l-1)
c
       do l = 2, lpmax
        irot0(l) = irot0(l-1) + (l+l-1)*(l+l-1)
        call rotrecur (rotr(irot0(1),neq1),rotr(irot0(l-1),neq1),
     & rotr(irot0(l),neq1),l)
       enddo
      else ! 'all' keyword
       do ic = 1, neq
c
c.....rotation matrices for l=0 and l=1; mod(m+2,3)+1 transforms
c     m=(-1,0,1) into i=(2,3,1), i.e., (y,z,x)
c

c     irot0()........ pointer to first elemnt of R^l in rotr (), which
c                     is 1+l*(2l-1)*(2l+1)/3
        irot0(0) = 1
        rotr(1,ic) = 1d0 !R_{0,0}^0=1
        i = 2
        irot0(1) = 2
        do m2 = -1, 1
         i2 = mod(m2+2,3) + 1
         do m1 = -1, 1
          i1 = mod(m1+2,3) + 1
c         R_{-1,-1}^1=rotop(2,2,ic)(i=2);R_{0,-1}^1=rotop(3,2,ic)(i=3)
c         R_{1,-1}^1=rotop(1,2,ic)(i=4);R_{-1,0}^1=rotop(2,3,ic)(i=5) 
c         R_{0,0}^1=rotop(3,3,ic)(i=6);R_{1,0}^1=rotop(1,3,ic)(i=7)
c         R_{-1,1}^1=rotop(2,1,ic)(i=8);R_{0,1}^1=rotop(3,1,ic)(i=9)
c         R_{1,1}^l=rotop(1,1,ic)(i=10)
          rotr(i,ic) = rotop(i1,i2,ic)
          i = i + 1
         enddo
        enddo
c
c.....loop over l values, obtaining each R^l by recurrence from R^(l-1)
c
        do l = 2, lpmax
         irot0(l) = irot0(l-1) + (l+l-1)*(l+l-1)
         call rotrecur (rotr(irot0(1),ic),rotr(irot0(l-1),ic),
     & rotr(irot0(l),ic),l)
        enddo
       enddo
      endif
c
c.....End subroutine
c
      return
      end subroutine
