
c----------------------------------------------------------------------
c
      subroutine shellrholm ()
c---------------------------------------------------------------------
      use datos
      use libreria, only : error, setword, leng, itoa, setdble, setint, 
     &                     equiv
      implicit real*8 (a-h,o-z)
c....LOCAL VARIABLES
      integer :: wr, wq, wqn, tnmax, tnbmax, tnpmin, tnpmax, i, lp,
     & gl 
      real*8 :: cte
      logical :: ok1, ok2     
      character*16 :: chwr, chwq, chwqn
c
c.................................................................
c

c
c-----Read conditions of the run
c

c
c---------Read the promolden_.pdat file name
c         and extract information
c
      read (stdin1,500) line
      lp=1
      if (setword(word,line,lp)) then
        word=word(1:leng(word))
        if (word.eq.'data') then
          if (setword(word,line,lp)) then
            open (stdin2,file=word(1:leng(word)),status='old',
     $      action='read',iostat = nios)
            if (nios.ne. 0)
     &       call error ('shellrholm','error while opening '//
     &       word(1:leng(word)), faterr)
            call datarholm ()
            close (stdin2)
          else
            call error ('shellrholm','First order is difference
     &      that "data promolden_.pdat"', faterr)
          endif
        else
          call error ('shellrholm','First order is difference
     &    that "data promolden_.pdat"', faterr)
        endif  
      else
        call error ('shellrholm','First order is difference
     &   that "data promolden_.pdat"', faterr) 
      endif  
 1    read (stdin1,500,end=2) line
      lp=1
      if (setword(word,line,lp)) then
        word=word(1:leng(word))
        if (word.eq.'end') then
          goto 3
c
c---------Read the outputfile name
c
        else if (word.eq.'outputname') then
          if (setword(word,line,lp)) then
            fileout = word(1:leng(word))
          else   
            fileout = filename
          endif
          output=.true.
          goto 1
c
c---------Read the promolden_.scr1 file name
c         and extract Rlm(r) values for the electron density
c
        else if (word.eq.'rholm') then 
          if (setword(word,line,lp)) then
            open (stdin2, file=word(1:leng(word)), status='old',
     &       access='direct', recl=2*lmax21, action='read',
     &       form='unformatted', iostat=nios)
            if (nios.ne. 0)
     &        call error ('shellrholm','error while opening '//
     &word(1:leng(word)), faterr)
            allocate (rholm(0:nr-1,1:neq,0:lmax2), stat=ier)
            if (ier.ne.0)
     &        call error ('shellrholm', 'Cannot allocate rholm', faterr)
            call calcrho (nr,lmax2,rholm)
            close (stdin2)
            scr=.true.
            goto 1
          else
            call error ('shellrholm','promolden_.scr1 file has not been
     &      identify', faterr)
          endif
c
c---------Read the promolden_.scr1b file name
c         and extract Rlm(r) values for the electron density 
c         (inside betasphere)
c
        else if (word.eq.'brholm') then 
          if (bsphere) then
            if (setword(word,line,lp)) then
              open (stdin2, file=word(1:leng(word)), status='old',
     &        access='direct', recl=2*llmax21, action='read',
     &        form='unformatted', iostat=nios)
             if (nios.ne. 0)
     &         call error ('shellrholm','error while opening '//
     &word(1:leng(word)), faterr)
             allocate (brholm(0:nrb-1,1:neq,0:llmax2), stat=ier)
             if (ier.ne.0)
     &        call error ('shellrholm', 'Cannot allocate brholm',faterr)
             call calcrho (nrb,llmax2,brholm)
             close (stdin2)
             scrb=.true.
             goto 1
            else
              call error ('shellrholm','promolden_.scr1b file has not
     & been identify', faterr)
            endif
          else
            call error ('shellrholm','Do not exist betasphere in
     &      promolden_.pdat file', warning)
            goto 1
          endif
        else
         goto 1
        endif
      else
        goto 1
      endif 
c
c-----Test if the essential input has been read
c
 2    call error ('shellrholm', 'Can not find "end" order', faterr)
 3     if (.not.output)
     & call error ('shellrholm', 'outputname file has not been
     & defined', faterr)
      if (bsphere.and..not.scrb) then
       if (.not.scr) then
        call error ('shellrholm', 'promolden_.scr1 file and
     &  promolden_.scr1b file have not been defined', faterr)
       else
        call error ('shellrholm', 'promolden_.scr1b file has not been
     &  defined', warning)
       endif
      endif
      if (.not.scr.and..not.bsphere)
     & call error ('shellrholm', 'promolden_.scr1 and promolden_.scr1b 
     & files have not been defined', faterr)
      if (.not.scr)
     & call error ('shellrholm', 'promolden_.scr1 file has not been
     & defined', warning)
c
c-----Open fileout.rhdat
c
      open (stdout1,
     & file=fileout(1:leng(fileout))//'.rhdat',status='unknown',
     & iostat=nios)
      if (nios.ne.0)
     & call error ('shellrholm','error while opening '//
     & fileout(1:leng(fileout))//'.rhdat', faterr)
      write (stdout1,500) 'fileout: '//fileout(1:leng(fileout))
      if (scr) then
       if (bsphere) then
        write (stdout1,500) 'Rlm(r) have been defined outside of
     & betasphere!'
       else
        write (stdout1,500) 'Rlm(r) have been defined!'   
       endif
      endif
      if (scrb) write (stdout1,500) 'Rlm(r) have been defined inside
     & of betasphere!'
C
C     ***************************************************************
C     *                                                             *
C     *    Read tasks to be done until an 'end of file' is found    *
C     *                                                             *
C     ***************************************************************
C
C
c
c-----Initializations
c
      wr=0 !Initialize counters
      wq=0 
      wqn=0
 4    read (stdin1,500,end=5) line
      lp=1
      if (setword(word,line,lp)) then
        word=word(1:leng(word))
        if (word.eq.'end') then
         goto 5
c
c-------Calculate multipole moments for 
c       Multipolar Expansion (ME)
c
        else if (word.eq.'calcqlm') then
         if (.not.qlm) then
          if (scr) then
           allocate (rhoqlm(1:neq,0:lmax2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate rhoqlm', faterr)
           rhoqlm=0.d0 !Initializations
           call calcqlm (lmax,lmax2,nr,rmesh,wrmesh,rholm,rhoqlm)
           write (stdout1,500) 'Qlm have been calculated!'
           qlm=.true.
           goto 4
          else
           call error ('shellrholm', 'rhoqlm can not calculate because
     & promolden_.src1 file has not been defined', warning)
           goto 4
          endif
         else 
          rhoqlm=0.d0 !Initializations
          call calcqlm (lmax,lmax2,nr,rmesh,wrmesh,rholm,rhoqlm)
          write (stdout1,500) 'Qlm have been calculated!'
          goto 4
         endif
        else if (word.eq.'calcbqlm') then
         if (.not.bqlm) then
          if (scrb) then
           allocate (brhoqlm(1:neq,0:llmax2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate brhoqlm', faterr)
           brhoqlm = 0.d0 !Initializations
           call calcqlm (llmax,llmax2,nrb,rbet,wrbet,brholm,brhoqlm)
           write (stdout1,500) 'Qlm have been calculated
     & (inside betasphere)!'
           bqlm=.true.
           goto 4
          else
           call error ('shellrholm', 'brhoqlm can not calculate because
     & promolden_.src1b file has not been defined', warning)
           goto 4
          endif
         else
          brhoqlm = 0.d0 !Initializations
          call calcqlm (llmax,llmax2,nrb,rbet,wrbet,brholm,brhoqlm)
          write (stdout1,500) 'Qlm have been calculated
     & (inside betasphere)!'
          goto 4
         endif
        else if (word.eq.'calcqlmtot') then
         if (.not.qtot) then
          if (qlm.and.bqlm) then
           allocate (qlmtot(1:neq,0:lpmin*(lpmin+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate qlmtot', faterr)
           call calcqtot ()
           write (stdout1,500) 'Qlmtot have been calculated!'
           qtot=.true.
           goto 4 
          else
           call error ('shellrholm', 'qlmtot can not calculate because
     & rhoqlm and/or brhoqlm has not been defined', warning)
           goto 4
          endif
         else     
          call calcqtot ()
          write (stdout1,500) 'Qlmtot have been calculated!'
          goto 4
         endif 
c
c-------Calculate multipole moments for 
c       Ruedenberg's Bipolar Expansion (BE)
c
        else if (word.eq.'scfactor') then
          if (.not.setdble (afactor,line,lp)) then
           call error ('shellrholm','afactor has not been defined
     & in "scfactor" order', warning)
           goto 4
          endif
          if (afactor.le.TINY) 
     &     call error ('shellrholm','afactor is lower or equal than
     & 1.d-20', faterr) 
          write (stdout1,600) 'a_factor =',afactor 
          logfac=.true.
          goto 4
        else if (word.eq.'calcqnlm') then
          if (.not.setint (nmax,line,lp)) then
           call error ('shellrholm','nmax has not been defined in
     & "calcqnlm" order', warning) 
           goto 4
          endif 
          if (nmax.le.0) then
           call error ('shellrholm','nmax is lower or equal than
     & zero', warning) 
           goto 4
          endif   
          tnmax = nmax
          if (.not.qnlm) then 
           if (scr.and.logfac) then
            allocate (rhoqnlm(1:neq,0:nmax,0:lmax2), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm','Cannot allocate rhoqnlm',
     & faterr) 
            rhoqnlm=0.d0 !Initializations
            call calcqnlm(nmax,lmax,lmax2,nr,rmesh,wrmesh,rholm,rhoqnlm)
            write (stdout1,700) 'Qnlm have been calculated with nmax
     & =',nmax
            qnlm=.true.
            goto 4
           else
            call error ('shellrholm','rhoqnlm can not calculate because
     & promolden_.scr1 file has not been defined and/or afactor has not
     & been defined', warning)
            goto 4
           endif
          else
           deallocate (rhoqnlm, stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot deallocate rhoqnlm',
     & faterr)
           allocate (rhoqnlm(1:neq,0:nmax,0:lmax2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm','Cannot allocate rhoqnlm',
     & faterr)
           rhoqnlm=0.d0 !Initializations
           call calcqnlm(nmax,lmax,lmax2,nr,rmesh,wrmesh,rholm,rhoqnlm)
           write (stdout1,700) 'Qnlm have been calculated with nmax
     & =',nmax
           goto 4
          endif
        else if (word.eq.'calcbqnlm') then
          if (.not.setint (nbmax,line,lp)) then
           call error ('shellrholm','nbmax has not been defined in
     & "calcbqnlm" order', warning)
           goto 4
          endif 
          if (nbmax.le.0) then
           call error ('shellrholm','nbmax is lower or equal than
     & zero', warning)
           goto 4
          endif    
          tnbmax = nbmax
          if (.not.bqnlm) then
           if (scrb.and.logfac) then
            allocate (brhoqnlm(1:neq,0:nbmax,0:llmax2), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm','Cannot allocate brhoqnlm',
     & faterr)
            brhoqnlm=0.d0 !Initializations
            call calcqnlm(nbmax,llmax,llmax2,nrb,rbet,wrbet,brholm,
     & brhoqnlm)
            write (stdout1,700) 'Qnlm have been calculated (inside
     & bsphere) with nbmax =',nbmax
            bqnlm=.true.
            goto 4
           else
            call error ('shellrholm','brhoqnlm can not calculate because
     & promolden_.scr1 file has not been defined or/and afactor has not
     & been defined', warning)
            goto 4
           endif
          else
           deallocate (brhoqnlm, stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot deallocate brhoqnlm',
     & faterr)
           allocate (brhoqnlm(1:neq,0:nbmax,0:llmax2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm','Cannot allocate brhoqnlm',
     & faterr)
           brhoqnlm=0.d0 !Initializations
           call calcqnlm (nbmax,llmax,llmax2,nrb,rbet,wrbet,brholm,
     & brhoqnlm)
           write (stdout1,700) 'Qnlm have been calculated (inside
     & bsphere) with nbmax =',nbmax
           goto 4
          endif
        else if (word.eq.'calcqnlmtot') then
         if (.not.qntot) then
          if (qnlm.and.bqnlm) then
           npmin=min(nmax,nbmax)
           npmax=max(nmax,nbmax)
           allocate (qnlmtot(1:neq,0:npmin,0:lpmin*(lpmin+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm','Cannot allocate qnlmtot', faterr)
           call calcqntot ()
           write (stdout1,700) 'Qnlmtot have been calculated with npmin
     & =',npmin
           qntot=.true.
           goto 4
          else
           call error ('shellrholm','qnlmtot can not calculate because
     & rhoqnlm and/or brhoqnlm has not been defined', warning)
           goto 4
          endif
         else
          npmin=min(nmax,nbmax)
          npmax=max(nmax,nbmax)
          deallocate (qnlmtot, stat=ier)
          if (ier.ne.0)
     &     call error ('shellrholm', 'Cannot deallocate qnlmtot',
     & faterr)
          allocate (qnlmtot(1:neq,0:npmin,0:lpmin*(lpmin+2)), stat=ier)
          if (ier.ne.0)
     &     call error ('shellrholm','Cannot allocate qnlmtot', faterr)
          call calcqntot ()
          write (stdout1,700) 'Qnlmtot have been calculated with npmin
     & =',npmin
          goto 4
         endif  
c
c-------Calculate electrostatic interaction between no equivalent
c       topological atoms using ME
c
        else if (word.eq.'calcelecME') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "calcelecME" order', warning)
          goto 4
         endif  
         if (.not.setint (ltot,line,lp)) then
          call error ('shellrholm','ltot, neq1 and
     & neq2 have not been defined in "calcelecME" order', warning)
          goto 4
         endif
         if (ltot.lt.0) then
          call error ('shellrholm','ltot is a negative integer
     & in "calcelecME" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "calcelecME" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "calcelecME" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "calcelecME" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "calcelecME" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "calcelecME" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom 
     & in "calcelecME" order', warning)
          goto 4
         endif  
         if (.not.logelecME) then
          if (bsphere.and..not.qtot) then
           call error ('shellrholm','Vee(ME) can not calculate because
     & qlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qlm) then
           call error ('shellrholm','Vee(ME) can not calculate because
     & rhoqlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (ltot.gt.lpmin) then
             call error ('shellrholm','ltot is greather than lpmin in
     & "calcelecME" order', warning)
             goto 4
            endif
           else
            if (ltot.gt.lmax) then
             call error ('shellrholm','ltot is greather than lmax in
     & "calcelecME" order', warning)
             goto 4
            endif
           endif
           call mod_elecME (1)
           logelecME=.true.
           goto 4
          endif
         else
          if (bsphere) then
           if (ltot.gt.lpmin) then
            call error ('shellrholm','ltot is greather than lpmin in
     & "calcelecME" order', warning)
            goto 4
           endif
          else
           if (ltot.gt.lmax) then
            call error ('shellrholm','ltot is greather than lmax in
     & "calcelecME" order', warning)
            goto 4
           endif
          endif
          call mod_elecME (1)
          goto 4
         endif
        else if (word.eq.'autcalcME') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "autcalcME" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "autcalcME" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "autcalcME" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "autcalcME" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "autcalcME" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "autcalcME" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     & in "autcalcME" order', warning)
          goto 4
         endif
         if (.not.logautME) then
          if (bsphere.and..not.qtot) then
           call error ('shellrholm','Vee(ME) can not calculate because
     & qlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qlm) then
           call error ('shellrholm','Vee(ME) can not calculate because
     & rhoqlm have not been defined', warning)
           goto 4
          endif
          if (bsphere) then
           maxl=lpmin
          else
           maxl=lmax
          endif
          call mod_elecME (2) 
          logautME=.true.
          goto 4
         else
          if (bsphere) then
           maxl=lpmin
          else
           maxl=lmax
          endif
          call mod_elecME (2)
          goto 4
         endif 
c
c-------Calculate electrostatic interaction between no equivalent
c       topological atoms using BE
c       
        else if (word.eq.'calcelecBE') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (ntot,line,lp)) then
          call error ('shellrholm','ntot, ltot, neq1 and
     &  neq2 have not been defined in "calcelecBE" order', warning)
          goto 4
         endif
         if (ntot.lt.0) then
          call error ('shellrholm','ntot is a negative integer
     & in "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (ltot,line,lp)) then
          call error ('shellrholm','ltot, neq1 and
     &  neq2 have not been defined in "calcelecBE" order', warning)
          goto 4
         endif
         if (ltot.lt.0) then
          call error ('shellrholm','ltot is a negative integer
     & in "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "calcelecBE" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "calcelecBE" order', warning)
          goto 4
         endif 
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "calcelecBE" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     &  in "calcelecBE" order', warning)
          goto 4
         endif
         if (.not.logelecBE) then
          if (bsphere.and..not.qntot) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & qnlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qnlm) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & rhoqnlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (ltot.gt.lpmin) then
             call error ('shellrholm','ltot is greather than lpmin
     & in "calcelecBE" order', warning)
             goto 4
            endif
            if (ntot.gt.npmin) then
             call error ('shellrholm','ntot is greather than npmin
     & in "calcelecBE" order', warning)
             goto 4
            endif 
           else
            if (ltot.gt.lmax) then
             call error ('shellrholm','ltot is greather than lmax
     & in "calcelecBE" order', warning)
             goto 4
            endif
            if (ntot.gt.nmax) then
             call error ('shellrholm','ntot is greather than nmax
     & in "calcelecBE" order', warning)
             goto 4
            endif
           endif
           call mod_elecBE (1)
           logelecBE=.true. 
           goto 4
          endif
         else 
          if (bsphere) then
           if (ltot.gt.lpmin) then
            call error ('shellrholm','ltot is greather than lpmin
     & in "calcelecBE" order', warning)
            goto 4
           endif
           if (ntot.gt.npmin) then
            call error ('shellrholm','ntot is greather than npmin
     & in "calcelecBE" order', warning)
            goto 4
           endif
          else
           if (ltot.gt.lmax) then
            call error ('shellrholm','ltot is greather than lmax
     & in "calcelecBE" order', warning)
            goto 4
           endif
           if (ntot.gt.nmax) then
            call error ('shellrholm','ntot is greather than nmax
     & in "calcelecBE" order', warning)
            goto 4
           endif
          endif
          call mod_elecBE (1) 
          goto 4
         endif 
        else if (word.eq.'convelecBE') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "convelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (ntot,line,lp)) then
          call error ('shellrholm','ntot, ltot, neq1 and
     &  neq2 have not been defined in "convelecBE" order', warning)
          goto 4
         endif
         if (ntot.lt.4) then
          call error ('shellrholm','ntot is lower than 4
     & in "convelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (ltot,line,lp)) then
          call error ('shellrholm','ltot, neq1 and
     &  neq2 have not been defined in "convelecBE" order', warning)
          goto 4
         endif
         if (ltot.lt.0) then
          call error ('shellrholm','ltot is a negative integer
     & in "convcelecBE" order', warning)
          goto 4
         endif
         if (.not.setdble(convt,line,lp)) then
          call error ('shellrholm','convt has not been defined in
     & "convelecBE" order', warning)
          goto 4
         endif
         if (convt.le.0d0) then
          call error ('shellrholm','convt is a negative or null
     & number in "convelecBE" order', warning)
          goto 4
         endif 
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "convelecBE" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "convelecBE" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "convelecBE" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "convelecBE" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "convelecBE" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     &  in "convelecBE" order', warning)
          goto 4
         endif
         if (.not.logconvBE) then
          if (bsphere.and..not.qntot) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & qnlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qnlm) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & rhoqnlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (ltot.gt.lpmin) then
             call error ('shellrholm','ltot is greather than lpmin
     & in "convelecBE" order', warning)
             goto 4
            endif
            if (ntot.gt.npmin) then
             call error ('shellrholm','ntot is greather than npmin
     & in "convelecBE" order', warning)
             goto 4
            endif
           else
            if (ltot.gt.lmax) then
             call error ('shellrholm','ltot is greather than lmax
     & in "convelecBE" order', warning)
             goto 4
            endif
            if (ntot.gt.nmax) then
             call error ('shellrholm','ntot is greather than nmax
     & in "convelecBE" order', warning)
             goto 4
            endif
           endif
           call mod_elecBE (3)
           logconvBE=.true.
           goto 4
          endif
         else
          if (bsphere) then
           if (ltot.gt.lpmin) then
            call error ('shellrholm','ltot is greather than lpmin
     & in "convelecBE" order', warning)
            goto 4
           endif
           if (ntot.gt.npmin) then
            call error ('shellrholm','ntot is greather than npmin
     & in "convelecBE" order', warning)
            goto 4
           endif
          else
           if (ltot.gt.lmax) then
            call error ('shellrholm','ltot is greather than lmax
     & in "convelecBE" order', warning)
            goto 4
           endif
           if (ntot.gt.nmax) then
            call error ('shellrholm','ntot is greather than nmax
     & in "convelecBE" order', warning)
            goto 4
           endif
          endif
          call mod_elecBE (3)
          goto 4
         endif
        else if (word.eq.'autcalcBE') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "autcalcBE" order', warning)
          goto 4
         endif
         if (.not.setint (maxn,line,lp)) then
          call error ('shellrholm','maxn, neq1 and
     &  neq2 have not been defined in "autcalcBE" order', warning)
          goto 4
         endif
         if (maxn.lt.0) then
          call error ('shellrholm','maxn is a negative integer
     & in "autcalcBE" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "autcalcBE" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "autcalcBE" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "autcalcBE" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "autcalcBE" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "autcalcBE" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     & in "autcalcBE" order', warning)
          goto 4
         endif
         if (.not.logautBE) then
          if (bsphere.and..not.qntot) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & qnlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qnlm) then
           call error ('shellrholm','Vee(BE) can not calculate because
     & rhoqnlm have not been defined', warning)
           goto 4
          endif
          if (bsphere) then
           maxl=lpmin
          else
           maxl=lmax
          endif
          call mod_elecBE (2)
          logautBE=.true.
          goto 4
         else
          if (bsphere) then
           maxl=lpmin
          else
           maxl=lmax
          endif
          call mod_elecBE (2)
          goto 4
         endif  
c
c-------Calculate Pade & ERA aproximations for ME
c
        else if (word.eq.'rank') then
         if (.not.setint (rank,line,lp)) then
          call error ('shellrholm', 'rank in Rational approximations
     & has not been defined in "rank" order', warning)
          goto 4
         endif
         if (rank.lt.4) 
     &    call error ('shellrholm', 'rank is lower than 4', faterr)
         write (stdout1,700) 'rank in Rational approximations =',rank
         logrank=.true.
         goto 4
        else if (word.eq.'pade') then 
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "pade" order', warning)
          goto 4
         endif
         if (.not.setint(m,line,lp)) then
          call error ('shellrholm', 'm, n, neq1 and neq2
     & have not been defined in "pade" order', warning)
          goto 4
         endif
         if (m.le.0) then
          call error ('shellrholm', 'Numerator polynomial degree is
     & lower or equal than zero in "pade" order', warning)
          goto 4
         endif  
         if (.not.setint(n,line,lp)) then
          call error ('shellrholm', 'n, neq1 and neq2
     & have not been defined in "pade" order', warning)
          goto 4
         endif
         if (n.le.0) then
          call error ('shellrholm', 'Denominator polynomial degree is
     & lower or equal than zero in "pade" order', warning)
          goto 4
         endif 
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "pade" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "pade" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "pade" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "pade" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "pade" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     & in "pade" order', warning)
          goto 4
         endif
         if (.not.logpade) then
          if (.not.logrank) then
           call error ('shellrholm', 'rank in Rational approximations
     & has not been defined', warning)
           goto 4
          endif
          if (bsphere.and..not.qtot) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because qlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qlm) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because rhoqlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (rank.gt.lpmin+1) then
             call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
             goto 4
            endif
           else
            if (rank.gt.lmax+1) then
             call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
             goto 4
            endif
           endif
          endif
          if (m+n+1.ne.rank) then
           call error ('shellrholm', 'm+n+1 is not equal to rank in
     & "pade" order', warning)
           goto 4
          endif 
          call mod_pade (1)
          logpade=.true.
          goto 4
         else
          if (bsphere) then
           if (rank.gt.lpmin+1) then
            call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
            goto 4
           endif
          else
           if (rank.gt.lmax+1) then
            call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
            goto 4
           endif
          endif
          if (m+n+1.ne.rank) then
           call error ('shellrholm', 'm+n+1 is not equal to rank in
     & "pade" order', warning)
           goto 4
          endif
          call mod_pade (1)
          goto 4
         endif
        else if (word.eq.'autpade') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "autpade" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "autpade" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "autpade" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "autpade" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "autpade" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "autpade" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     & in "autpade" order', warning)
          goto 4
         endif
         if (.not.logautp) then
          if (.not.logrank) then
           call error ('shellrholm', 'rank in Rational approximations
     & has not been defined', warning)
           goto 4
          endif
          if (bsphere.and..not.qtot) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because qlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qlm) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because rhoqlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (rank.gt.lpmin+1) then
             call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
             goto 4
            endif
           else
            if (rank.gt.lmax+1) then
             call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
             goto 4
            endif
           endif
          endif
          call mod_pade (2)
          logautp=.true.
          goto 4
         else
          if (bsphere) then
           if (rank.gt.lpmin+1) then
            call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
            goto 4
           endif
          else
           if (rank.gt.lmax+1) then
            call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
            goto 4
           endif
          endif
          call mod_pade (2)
          goto 4 
         endif
       else if (word.eq.'era') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "era" order', warning)
          goto 4
         endif
         if (.not.setint(m,line,lp)) then
          call error ('shellrholm', 'm, n, alpha, neq1
     & and neq2 have not been defined in "era" order', warning)
          goto 4
         endif
         if (m.le.0) then
          call error ('shellrholm', 'Numerator polynomial degree is
     & lower or equal than zero in "era" order', warning)
          goto 4
         endif
         if (.not.setint(n,line,lp)) then
          call error ('shellrholm', 'n, alpha, neq1 and
     & neq2 have not been defined in "era" order', warning)
          goto 4
         endif
         if (n.le.0) then
          call error ('shellrholm', 'Denominator polynomial degree is
     & lower or equal than zero in "era" order', warning)
          goto 4
         endif
         if (.not.setdble(alpha,line,lp)) then
          call error ('shellrholm', 'alpha, neq1 and neq2 have not been
     & defined in "era" orden', warning)
          goto 4
         endif
         if (alpha.le.TINY) then
          call error ('shellrholm', 'alpha is lower or equal than
     & 1.d-20 in "era" order', warning)
          goto 4
         endif  
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "era" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "era" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "era" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "era" order', warning)
          goto 4
         endif
         ok1 = equiv(eq1,neq1)
         ok2 = equiv(eq2,neq2)
         if (.not.ok1) then
          call error ('shellrholm','eq1 is not a atom
     & in "era" order', warning)
          goto 4
         endif
         if (.not.ok2) then
          call error ('shellrholm','eq2 is not a atom
     & in "era" order', warning)
          goto 4
         endif
         if (.not.logera) then
          if (.not.logrank) then
           call error ('shellrholm', 'rank in Rational approximations
     & has not been defined', warning)
           goto 4
          endif
          if (bsphere.and..not.qtot) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because qlmtot have not been defined', warning)
           goto 4
          else if (.not.bsphere.and..not.qlm) then
           call error ('shellrholm', 'Rational approximations can not
     & calculate because rhoqlm have not been defined', warning)
           goto 4
          else
           if (bsphere) then
            if (rank.gt.lpmin+1) then
             call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
             goto 4
            endif
           else
            if (rank.gt.lmax+1) then
             call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
             goto 4
            endif
           endif
          endif
          if (m+n+1.ne.rank) then
           call error ('shellrholm', 'm+n+1 is not equal to rank in
     & "era" order', warning)
           goto 4
          endif
          call mod_era (1)
          logera=.true.
          goto 4
         else
          if (bsphere) then
           if (rank.gt.lpmin+1) then
            call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
            goto 4
           endif
          else
           if (rank.gt.lmax+1) then
            call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
            goto 4
           endif
          endif
          if (m+n+1.ne.rank) then
           call error ('shellrholm', 'm+n+1 is not equal to rank in
     & "era" order', warning)
           goto 4
          endif
          call mod_era (1)
          goto 4
         endif
         else if (word.eq.'autera') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "autera" order', warning)
          goto 4
         endif
          if (.not.setdble(alpha,line,lp)) then
           call error ('shellrholm', 'alpha, neq1 and neq2 have not been
     & defined in "autera" orden', warning)
           goto 4
          endif
          if (alpha.le.TINY) then
           call error ('shellrholm', 'alpha is lower or equal than
     & 1.d-20', warning)
           goto 4
          endif
          if (.not.setint (eq1,line,lp)) then
           call error ('shellrholm','eq1 and eq2 have not been defined
     & in "autera" order', warning)
           goto 4
          endif
          if (eq1.le.0) then
           call error ('shellrholm','eq1 is a negative or null
     & integer in "autera" order', warning)
           goto 4
          endif
          if (.not.setint (eq2,line,lp)) then
           call error ('shellrholm','eq2 have not been defined
     & in "autera" order', warning)
           goto 4
          endif
          if (eq2.le.0) then
           call error ('shellrholm','eq2 is a negative or null
     & integer in "autera" order', warning)
           goto 4
          endif
          ok1 = equiv(eq1,neq1)
          ok2 = equiv(eq2,neq2)
          if (.not.ok1) then
           call error ('shellrholm','eq1 is not a atom
     & in "autera" order', warning)
           goto 4
          endif
          if (.not.ok2) then
           call error ('shellrholm','eq2 is not a atom
     & in "autera" order', warning)
           goto 4
          endif
          if (.not.logautera) then 
           if (.not.logrank) then
            call error ('shellrholm', 'rank in Rational approximations
     & has not been defined', warning)
            goto 4
           endif
           if (bsphere.and..not.qtot) then
            call error ('shellrholm', 'Rational approximations can not
     & calculate because qlmtot have not been defined', warning)
            goto 4
           else if (.not.bsphere.and..not.qlm) then
            call error ('shellrholm', 'Rational approximations can not
     & calculate because rhoqlm have not been defined', warning)
            goto 4
           else
            if (bsphere) then
             if (rank.gt.lpmin+1) then
              call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
              goto 4
             endif
            else
             if (rank.gt.lmax+1) then
              call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
              goto 4
             endif
            endif
           endif
           call mod_era (2)
           logera=.true.
           goto 4
          else
           if (bsphere) then
            if (rank.gt.lpmin+1) then
             call error ('shellrholm', 'rank is greather than lpmin+1',
     & warning)
             goto 4
            endif
           else
            if (rank.gt.lmax+1) then
             call error ('shellrholm', 'rank is greather than lmax+1',
     & warning)
             goto 4
            endif
           endif
           call mod_era (2)
           goto 4
         endif
c
c-------Calculate electrostatic interaction between no equivalent
c       topological atoms using shift of multipole moments and ME
c
        else if (word.eq.'shift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "shift" order', warning)
          goto 4
         endif
         if (.not.setint (ltot,line,lp)) then
            call error ('shellrholm','ltot, neq1 and neq2 have not been
     & defined in "shift" order', warning)
          goto 4
         endif
         if (ltot.lt.4) then
          call error ('shellrholm','ltot is lower than 4 in
     & "shift" order', warning)
          goto 4
         endif
         if (.not.setint (eq1,line,lp)) then
          call error ('shellrholm','eq1 and eq2 have not been defined
     & in "shift" order', warning)
          goto 4
         endif
         if (eq1.le.0) then
          call error ('shellrholm','eq1 is a negative or null
     & integer in "shift" order', warning)
          goto 4
         endif
         if (.not.setint (eq2,line,lp)) then
          call error ('shellrholm','eq2 have not been defined
     & in "shift" order', warning)
          goto 4
         endif
         if (eq2.le.0) then
          call error ('shellrholm','eq2 is a negative or null
     & integer in "shift" order', warning)
          goto 4
         endif
          ok1 = equiv(eq1,neq1)
          ok2 = equiv(eq2,neq2)
          if (.not.ok1) then
           call error ('shellrholm','eq1 is not a atom
     & in "shift" order', warning)
           goto 4
          endif
          if (.not.ok2) then
           call error ('shellrholm','eq2 is not a atom
     & in "shift" order', warning)
           goto 4
          endif
          if (.not.logshift) then
           if (.not.bsphere) then
            call error ('shellrholm', 'Multipole moments can not shift
     & because betasphere does not exist', warning)
            goto 4
           endif  
           if (.not.qlm) then
            call error ('shellrholm', 'Multipole moments can not shift
     & because rhoqlm have not been defined', warning)
            goto 4
           endif
           if (bsphere.and..not.bqlm) then
           call error ('shellrholm', 'Multipole moments can not shift
     & because brhoqlm have not been defined', warning)
            goto 4
           endif
           if (ltot.gt.lpmin) then
            call error ('shellrholm', 'ltot is greather than lpmin
     & in "shift" order', warning)
            goto 4
           endif
           ltotm = 2*ltot
           allocate (il0(0:ltotm), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate il0', faterr)
           allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate slm', faterr)
           allocate (il02(0:ltot), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate il02', faterr)
           allocate (slm2(0:ltot*(ltot+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate slm2', faterr) 
           allocate (multim(1:6,0:ltot,0:ltot,1:2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate multim',
     & faterr) 
           allocate (numbl(0:ltot), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate numbl', faterr)
           do lp = 0, ltot
            cte = 4d0*pi/(2d0*lp+1d0)
            numbl(lp) = sqrt(cte)
           enddo 
           call read_multipole ()
           call mod_shift ()
           deallocate (slm, il0, slm2, il02, multim, numbl, stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0 and/or slm2 and/or il02 and/or multim and/or numbl', faterr) 
           logshift=.true.
           goto 4
          else
           if (ltot.gt.lpmin) then
            call error ('shellrholm', 'ltot is greather than lpmin
     & in "shift" order', warning)
            goto 4
           endif
           ltotm = 2*ltot
           allocate (il0(0:ltotm), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate il0', faterr)
           allocate (slm(0:ltotm*(ltotm+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate slm', faterr)
           allocate (il02(0:ltot), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate il02', faterr)
           allocate (slm2(0:ltot*(ltot+2)), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate slm2', faterr)
           allocate (multim(1:6,0:ltot,0:ltot,1:2), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate multim',
     & faterr)
           allocate (numbl(0:ltot), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate numbl', faterr)
           do lp = 0, ltot
            cte = 4d0*pi/(2d0*lp+1d0)
            numbl(lp) = sqrt(cte)
           enddo
           call read_multipole ()
           call mod_shift ()
           deallocate (slm, il0, slm2, il02, multim, numbl, stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot deallocate slm and/or
     & il0 and/or slm2 and/or il02 and/or multim and/or numbl', faterr)
           goto 4
          endif
        else if (word.eq.'meritshift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "meritshift" order', warning)
          goto 4
         endif
         if (.not.logmshift) then
          if (.not.bsphere) then
           call error ('shellrholm', 
     & 'Multipole moments can not shift because betasphere does not
     &  exist', warning)
           goto 4
          endif  
          if (.not.qlm) then
           call error ('shellrholm', 
     &'Multipole moments can not shift because rhoqlm have not been
     & defined', warning)
           goto 4
          endif
          if (bsphere.and..not.bqlm) then
         call error ('shellrholm',
     &'Multipole moments can not shift because brhoqlm have not
     & been defined', warning)
           goto 4
          endif
          call mod_mshift ()
          logmshift=.true.
          goto 4
         else
           call mod_mshift ()
           goto 4
         endif
        else if (word.eq.'minimumshift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "minimumshift" order', warning)
          goto 4
         endif
         if (.not.logmmshift) then
          if (.not.bsphere) then
           call error ('shellrholm',
     & 'Multipole moments can not shift because betasphere does not
     &  exist', warning)
           goto 4
          endif
          if (.not.qlm) then
           call error ('shellrholm',
     &'Multipole moments can not shift because rhoqlm have not been
     & defined', warning)
           goto 4
          endif
          if (bsphere.and..not.bqlm) then
         call error ('shellrholm',
     &'Multipole moments can not shift because brhoqlm have not
     & been defined', warning)
           goto 4
          endif
          call mod_mmshift ()
          logmmshift=.true.
          goto 4
         else
           call mod_mmshift ()
           goto 4
         endif
        else if (word.eq.'minimum2shift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "minimum2shift" order', warning)
          goto 4
         endif
         if (.not.logmmmshift) then
          if (.not.bsphere) then
           call error ('shellrholm',
     & 'Multipole moments can not shift because betasphere does not
     &  exist', warning)
           goto 4
          endif
          if (.not.qlm) then
           call error ('shellrholm',
     &'Multipole moments can not shift because rhoqlm have not been
     & defined', warning)
           goto 4
          endif
          if (bsphere.and..not.bqlm) then
         call error ('shellrholm',
     &'Multipole moments can not shift because brhoqlm have not
     & been defined', warning)
           goto 4
          endif
          call mod_mmmshift ()
          logmmmshift=.true.
          goto 4
         else
           call mod_mmmshift ()
           goto 4
         endif
        else if (word.eq.'minimum3shift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "minimum3shift" order', warning)
          goto 4
         endif
         if (.not.logmcshift) then
          if (.not.bsphere) then
           call error ('shellrholm',
     & 'Multipole moments can not shift because betasphere does not
     &  exist', warning)
           goto 4
          endif
          if (.not.qlm) then
           call error ('shellrholm',
     &'Multipole moments can not shift because rhoqlm have not been
     & defined', warning)
           goto 4
          endif
          if (bsphere.and..not.bqlm) then
         call error ('shellrholm',
     &'Multipole moments can not shift because brhoqlm have not
     & been defined', warning)
           goto 4
          endif
          call mod_mcshift ()
          logmcshift=.true.
          goto 4
         else
           call mod_mcshift ()
           goto 4
         endif
        else if (word.eq.'compshift') then
         if (lognotel) then
          call error ('shellrholm', 'Rlm(r) have been rotated before
     & "compshift" order', warning)
          goto 4
         endif
         if (.not.logcshift) then
          if (.not.bsphere) then
           call error ('shellrholm', 
     & 'Multipole moments can not shift because betasphere does not
     &  exist', warning)
           goto 4
          endif  
          if (.not.qlm) then
           call error ('shellrholm', 
     &'Multipole moments can not shift because rhoqlm have not been
     & defined', warning)
           goto 4
          endif
          if (bsphere.and..not.bqlm) then
         call error ('shellrholm',
     &'Multipole moments can not shift because brhoqlm have not
     & been defined', warning)
           goto 4
          endif
          call mod_cshift ()
          logcshift=.true.
          goto 4
         else
          call mod_cshift ()
          goto 4
        endif
c
c-------Rotations for rholm and brholm
c
        else if (word.eq.'rotmat') then
          if (.not.logrotm) then
           allocate (rotop(3,3,neq), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate rotop', faterr)
           allocate (irot0(0:lpmax), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate irot0', faterr)
           maxrotr = (lpmax+1)*(2*lpmax+1)*(2*lpmax+3)/3
           allocate (rotr(maxrotr,neq), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate rotr', faterr)
           call rotmax ()
           logrotm=.true.
           goto 4
          else
           call rotmax ()
           goto 4
          endif 
        else if (word.eq.'rotvec') then
          if (.not.logrotm) then
           allocate (rotop(3,3,neq), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate rotop', faterr)
           allocate (irot0(0:lpmax), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate irot0', faterr)
           maxrotr = (lpmax+1)*(2*lpmax+1)*(2*lpmax+3)/3
           allocate (rotr(maxrotr,neq), stat=ier)
           if (ier.ne.0)
     &      call error ('shellrholm', 'Cannot allocate rotr', faterr)
           call rotvector ()
           logrotm=.true.
           goto 4
          else
           call rotvector ()
           goto 4
          endif          
         else if (word.eq.'rotdip') then
          if (.not.setint(gl,line,lp)) then
           call error ('shellrholm', 'Cannot find integer that
     & indicates degrees of freedom in "rotdip" order', warning)
           goto 4
          endif
          if (gl.ne.1.and.gl.ne.2) then
           call error ('shellrholm', 'Degrees of freedom are
     & different to 1 or 2 in "rotdip" order', warning)
           goto 4
          endif 
          if (gl.eq.1) logliber = .true. 
          if (.not.setword(word,line,lp)) then
           call error ('shellrholm', 'Cannot find "inside" or
     & "outside" or "total" order in "rotdip" order', warning)
           goto 4
          endif
          word=word(1:leng(word))
          if (word.eq.'inside') then
           if (.not.logrotm) then
            allocate (rotop(3,3,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotop', faterr)
            allocate (irot0(0:lpmax), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate irot0', faterr)
            maxrotr = (lpmax+1)*(2*lpmax+1)*(2*lpmax+3)/3
            allocate (rotr(maxrotr,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotr', faterr)
            call rotdip (1)
            logrotm=.true.
            goto 4
           else
            call rotdip (1)
            goto 4
           endif
          else if (word.eq.'outside') then
           if (.not.logrotm) then
            allocate (rotop(3,3,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotop', faterr) 
            allocate (irot0(0:lpmax), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate irot0', faterr)
            maxrotr = (lpmax+1)*(2*lpmax+1)*(2*lpmax+3)/3
            allocate (rotr(maxrotr,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotr', faterr)
            call rotdip (2)
            logrotm=.true.
            goto 4
           else
            call rotdip (2)
            goto 4
           endif
          else if (word.eq.'total') then
           if (.not.logrotm) then
            allocate (rotop(3,3,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotop', faterr) 
            allocate (irot0(0:lpmax), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate irot0', faterr)
            maxrotr = (lpmax+1)*(2*lpmax+1)*(2*lpmax+3)/3
            allocate (rotr(maxrotr,neq), stat=ier)
            if (ier.ne.0)
     &       call error ('shellrholm', 'Cannot allocate rotr', faterr)
            call rotdip (3)
            logrotm=.true.
            goto 4
           else
            call rotdip (3)
            goto 4
           endif
          else
           call error ('shellrholm', 'Cannot find "inside" or
     & "outside" or "total" order in "rotdip" order', warning)
           goto 4
          endif
c
c-------Write outputfiles
c
        else if (word.eq.'wrlm') then
          if (.not.scr.and..not.scrb) then
           call error ('shellrholm', 'Cannot write rholm and/or brholm
     & because have not been defined', warning)
           goto 4
          endif 
          wr = wr + 1
          chwr = itoa(wr)
          open (stdout,file=fileout(1:leng(fileout))//'.'
     & //chwr(1:leng(chwr))//'.rlm',status='unknown', iostat=nios)
          if (nios.ne. 0)
     &     call error ('shellrholm','error while opening '//
     & fileout(1:leng(fileout))//'.'//chwr(1:leng(chwr))//'.rlm',
     & faterr)
          call wrho ()
          write (stdout1,500) fileout(1:leng(fileout))//'.'
     & //chwr(1:leng(chwr))//'.rlm has been written'
          close (stdout)
          goto 4
        else if (word.eq.'wqlm') then
          if (.not.qlm.and..not.bqlm) then
           call error ('shellrholm', 'Cannot write rhoqlm and/or brhoqlm
     & and/or qlmtot because have not been defined', warning)
           goto 4
          endif
          wq = wq + 1
          chwq = itoa(wq)
          open (stdout, file=fileout(1:leng(fileout))//'.'
     & //chwq(1:leng(chwq))//'.qlm', status='unknown', iostat=nios)
          if (nios.ne. 0)
     &     call error ('shellrholm','error while opening '//
     & fileout(1:leng(fileout))//'.'//chwq(1:leng(chwq))//'.qlm',
     & faterr)
          call wqlm ()
          write (stdout1,500) fileout(1:leng(fileout))//'.'
     & //chwq(1:leng(chwq))//'.qlm has been written'
          close (stdout)
          goto 4
        else if (word.eq.'wqnlm') then
          if (.not.qnlm.and..not.bqnlm) then
           call error ('shellrholm', 'Cannot write rhoqnlm and/or
     &  brhoqnlm and/or qnlmtot because have not been defined', warning)
           goto 4
          endif
          if (qnlm.and.bqnlm)then
           tnpmin = min(tnmax,tnbmax)
           tnpmax = max(tnmax,tnbmax)
           if (tnpmin.ne.npmin) then
            call error ('shellrholm', 'Cannot write file.qlm because
     & rhoqnlm and brhoqnlm have different sizes', warning)
            goto 4
           endif
           if (tnpmax.ne.npmax) then
            call error ('shellrholm', 'Cannot write file.qlm because
     & rhoqnlm and brhoqnlm have different sizes', warning)
            goto 4
           endif
          endif  
          wqn = wqn + 1
          chwqn = itoa(wqn)
          open (stdout, file=fileout(1:leng(fileout))//'.'
     & //chwqn(1:leng(chwqn))//'.qnlm', status='unknown', iostat=nios)
          if (nios.ne. 0)
     &     call error ('shellrholm','error while opening '//
     & fileout(1:leng(fileout))//'.'//chwqn(1:leng(chwqn))//'.qnlm',
     & faterr)
          call wqnlm ()
          write (stdout1,500) fileout(1:leng(fileout))//'.'
     & //chwqn(1:leng(chwqn))//'.qnlm has been written'
          close (stdout)
          goto 4
        else
          goto 4
        endif
      else
        goto 4
      endif     
c
 5    continue
      write (*,500) ' RHOLM : End of run OK ! '
c
c-----Deallocate arrays
c
       close (stdout1)
       deallocate (charge, xyz, atnam, ineq, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate charge and/or xyz
     & and/or atnam and/or ineq', faterr)
       if (nop.gt.1) then
        deallocate (idx, oper, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate idx and/or  oper',
     & faterr)
       endif
       deallocate (ct, st, cp, sp, angw, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate ct and/or st and/or
     & cp and/or sp and/or angw', faterr)
       deallocate (xyzrho, rmesh, wrmesh, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate xyzrho and/or rmesh
     & and/or wrmesh', faterr)
       deallocate (ctb, stb, cpb, spb, angwb, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate ctb and/or stb 
     & and/or cpb and/or spb and/or angwb', faterr)
       deallocate (betrad, rbet, wrbet, stat=ier)
       if (ier.ne.0)
     &  call error ('shellrholm', 'Cannot deallocate betrad and/or rbet
     & and/or wrbet', faterr)
       if (scr) then
        deallocate (rholm, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate rholm', faterr)
       endif
       if (scrb) then
        deallocate (brholm, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate brholm', faterr)
       endif
       if (qlm) then
        deallocate (rhoqlm, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate rhoqlm', faterr) 
       endif
       if (bqlm) then
        deallocate (brhoqlm, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate brhoqlm', faterr)
       endif
       if (qtot) then
        deallocate (qlmtot, stat=ier)
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate qlmtot', faterr)
       endif
       if (logrotm) then
        deallocate (irot0, rotr, stat=ier) 
        if (ier.ne.0)
     &   call error ('shellrholm', 'Cannot deallocate irot0 and/or rotr'
     & ,faterr)
       endif    
c
c-----Formats
c
 500  format (a)
 600  format (a,2x,e23.16)
 700  format (a,2x,i5) 

c
c-----End of the subroutine
c
      end
