       subroutine wqlm ()
c--------------------------------------------------------------
c      Write Qlm values for the electron density
c--------------------------------------------------------------
        use datos, only: stdout, neq, lmax, llmax,
     & rhoqlm, brhoqlm, qlmtot, qlm, bqlm, qtot, lpmin, lpmax,
     & qlm, bqlm, qtot, ineq
        implicit real*8 (a-h,o-z)
c-----LOCAL VARIABLES
        integer :: ic, l, m, lm, in

      write (stdout,fmt=100)
c
c----write 'Qlm' values in a sequential ouputfile
c
      if (qlm.and.bqlm.and.qtot) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over angular quantum numbers (l,m)
        do l = 0, lpmax
         do m = -l, +l
          lm = l*(l+1) + m
          if (lpmin.eq.llmax) then
           if (l.le.lpmin) then
            write (stdout,fmt=200) in,l,m,brhoqlm(ic,lm),rhoqlm(ic,lm),
     & qlmtot(ic,lm)
           else
            write (stdout, fmt=201) in,l,m,rhoqlm(ic,lm) 
           endif
          else if (lpmin.eq.lmax) then
           if (l.le.lpmin) then
            write (stdout,fmt=200) in,l,m,brhoqlm(ic,lm),rhoqlm(ic,lm),
     & qlmtot(ic,lm)
           else
            write (stdout, fmt=202) in,l,m,brhoqlm(ic,lm)
           endif
          endif
         enddo
        enddo
       enddo
      else if (qlm.and.bqlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over angular quantum numbers (l,m)
        do l = 0, lpmax
         do m = -l, +l
          lm = l*(l+1) + m
          if (lpmin.eq.llmax) then
           if (l.le.lpmin) then
            write (stdout,fmt=203) in,l,m,brhoqlm(ic,lm),rhoqlm(ic,lm)
           else
            write (stdout, fmt=201) in,l,m,rhoqlm(ic,lm)
           endif
          else if (lpmin.eq.lmax) then
           if (l.le.lpmin) then
            write (stdout,fmt=203) in,l,m,brhoqlm(ic,lm),rhoqlm(ic,lm)
           else
            write (stdout, fmt=202) in,l,m,brhoqlm(ic,lm)
           endif
          endif
         enddo
        enddo
       enddo
      else if (qlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over angular quantum numbers (l,m)
        do l = 0, lmax
         do m = -l, +l
          lm = l*(l+1) + m
          write (stdout, fmt=201) in,l,m,rhoqlm(ic,lm)
         enddo
        enddo
       enddo
      else if (bqlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
c-----loop over angular quantum numbers (l,m)
        do l = 0, llmax
         do m = -l, +l
          lm = l*(l+1) + m
          write (stdout, fmt=202) in,l,m,brhoqlm(ic,lm)
         enddo
        enddo
       enddo
      endif

 100    format ('# QLM FOR ATOMIC PARTITIONS',/,'# ATOM',2x,
     &          'l',4x,'m',2x,'B-QLM',15x,'QLM',17x,'QLMTOT')
 200    format (1x,i3,2x,i3,2x,i3,3(2x,e20.12))
 201    format (1x,i3,2x,i3,2x,i3,22x,e20.12)
 202    format (1x,i3,2x,i3,2x,i3,2x,e20.12)
 203    format (1x,i3,2x,i3,2x,i3,2(2x,e20.12))
c
c.....end
c
      return
      end

