       subroutine wqnlm ()
c--------------------------------------------------------------
c      Write Qnlm values for the electron density
c--------------------------------------------------------------
        use datos, only: stdout, neq, lmax, llmax, nmax, nbmax,
     & rhoqnlm, brhoqnlm, qnlmtot, qnlm, bqnlm, qntot, lpmin, lpmax,
     & npmin, npmax, ineq
        implicit real*8 (a-h,o-z)
c-----LOCAL VARIABLES
        integer :: ic, n, l, m, lm, in

      write (stdout,fmt=100)
c
c----write 'Qnlm' values in a sequential ouputfile
c
      if (qnlm.and.bqnlm.and.qntot) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over number for expansion of spherical
c     Bessel functions
        do n = 0, npmax
c-----loop over angular quantum numbers (l,m)
         do l = 0, lpmax
          do m = -l, +l
           lm = l*(l+1) + m
           if (npmin.eq.nbmax) then
            if (n.le.npmin) then 
             if (lpmin.eq.llmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=200) in,n,l,m,brhoqnlm(ic,n,lm),
     &                           rhoqnlm(ic,n,lm),qnlmtot(ic,n,lm)
              else
               write (stdout, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm) 
              endif
             else if (lpmin.eq.lmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=200) in,n,l,m,brhoqnlm(ic,n,lm),
     &                          rhoqnlm(ic,n,lm),qnlmtot(ic,n,lm)
              else
               write (stdout, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
              endif
             endif
            else
             if (l.le.lmax) 
     &        write (stodut, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm) 
            endif 
           else if (npmin.eq.nmax) then
            if (n.le.npmin) then
             if (lpmin.eq.llmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=200) in,n,l,m,brhoqnlm(ic,n,lm),
     &                           rhoqnlm(ic,n,lm),qnlmtot(ic,n,lm)
              else
               write (stdout, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm)
              endif
             else if (lpmin.eq.lmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=200) in,n,l,m,brhoqnlm(ic,n,lm),
     &                          rhoqnlm(ic,n,lm),qnlmtot(ic,n,lm)
              else
               write (stdout, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
               endif
             endif
            else
             if (l.le.llmax) 
     &        write (stodut, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
            endif
           endif
          enddo                
         enddo
        enddo
       enddo
      else if (qnlm.and.bqnlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over number for expansion of spherical
c     Bessel functions
        do n = 0, npmax
c-----loop over angular quantum numbers (l,m)
         do l = 0, lpmax
          do m = -l, +l
           lm = l*(l+1) + m
           if (npmin.eq.nbmax) then
            if (n.le.npmin) then
             if (lpmin.eq.llmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=203) in,n,l,m,brhoqnlm(ic,n,lm),
     &                           rhoqnlm(ic,n,lm)
              else
               write (stdout, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm)
              endif
             else if (lpmin.eq.lmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=203) in,n,l,m,brhoqnlm(ic,n,lm),
     &                          rhoqnlm(ic,n,lm)
              else
               write (stdout, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
              endif
             endif
            else
             if (l.le.lmax)
     &        write (stodut, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm)
            endif
           else if (npmin.eq.nmax) then
            if (n.le.npmin) then
             if (lpmin.eq.llmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=203) in,n,l,m,brhoqnlm(ic,n,lm),
     &                           rhoqnlm(ic,n,lm)
              else
               write (stdout, fmt=201) in,n,l,m,rhoqnlm(ic,n,lm)
              endif
             else if (lpmin.eq.lmax) then
              if (l.le.lpmin) then
               write (stdout,fmt=203) in,n,l,m,brhoqnlm(ic,n,lm),
     &                          rhoqnlm(ic,n,lm)
              else
               write (stdout, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
               endif
             endif
            else
             if (l.le.llmax)
     &        write (stodut, fmt=202) in,n,l,m,brhoqnlm(ic,n,lm)
            endif
           endif
          enddo
         enddo
        enddo
       enddo
      else if (qnlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over number for expansion of spherical
c     Bessel functions
        do n = 0, nmax
c-----loop over angular quantum numbers (l,m)
         do l = 0, lmax
          do m = -l, +l
           lm = l*(l+1) + m
           write (stdout, fmt=201) in,l,m,rhoqnlm(ic,n,lm)
          enddo
         enddo
        enddo
       enddo
      else if (bqnlm) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over number for expansion of spherical
c     Bessel functions
        do n = 0, nbmax
c-----loop over angular quantum numbers (l,m)
         do l = 0, llmax
          do m = -l, +l
           lm = l*(l+1) + m
           write (stdout, fmt=202) in,l,m,brhoqnlm(ic,n,lm)
          enddo
         enddo
        enddo
       enddo
      endif

 100    format ('# QNLM FOR ATOMIC PARTITIONS',/,'# ATOM',2x,
     &          'n',4x,'l',4x,'m',2x,'B-QLM',15x,'QLM',17x,'QLMTOT')
 200    format (1x,i3,2x,i3,2x,i3,2x,i3,3(2x,e20.12))
 201    format (1x,i3,2x,i3,2x,i3,2x,i3,22x,e20.12)
 202    format (1x,i3,2x,i3,2x,i3,2x,i3,2x,e20.12)
 203    format (1x,i3,2x,i3,2x,i3,2x,i3,2(2x,e20.12))
c
c.....end
c
      return
      end

