      subroutine wrho ()
c--------------------------------------------------------------
c      Write Rlm(r) values for the electron density
c--------------------------------------------------------------
      use datos, only : stdout, neq, nrb, nr, llmax, lmax,
     &                 rbet, rmesh, rholm, brholm, scr, scrb, ineq
      implicit real*8 (a-h,o-z)
c-----LOCAL VARIABLES:
      integer :: ic, n, l, m, lm, in         
   
      write (stdout,fmt=100)
c
c-----write 'brholm' values in a sequential ouputfile
c
      if (scrb) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over radial points (inside b-sphere)
        do n = 0, nrb -1
c-----loop over angular quantum numbers (l,m) (inside b-sphere)
         do l = 0, llmax
          do m = -l, +l
           lm = l*(l+1) + m
           write (stdout,fmt=200) in,rbet(n,ic),l,m,brholm(n,ic,lm)
          enddo
         enddo
        enddo
       enddo
      endif  
c
c-----write 'rholm' values in a sequential ouputfile
c
      if (scr) then
c-----loop over no equivalent centers
       do ic = 1, neq
        in = ineq(ic)
c-----loop over radial points
        do n = 0, nr-1
c-----loop over angular quantum numbers (l,m) 
         do l = 0, lmax
          do m = -l, +l
           lm = l*(l+1) + m
           write (stdout,fmt=200) in,rmesh(n,ic),l,m,rholm(n,ic,lm)
          enddo
         enddo
        enddo
       enddo
      endif
c
c-----formats
c
 100    format ('# RHOLM FOR ATOMIC PARTITIONS',/,'# ATOM',2x,
     &          'RADIAL POINT',11x,'l',4x,'m',3x,'RHOLM')
 200    format (1x,i3,3x,e20.12,2x,i3,2x,i3,3x,e20.12)
c
c.....end
c
      return
      end
